"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.openCard = exports.openBluetoothAdapter = exports.onWifiConnected = exports.onSocketOpen = exports.onSocketMessage = exports.onNetworkStatusChange = exports.onMemoryWarning = exports.onHCEMessage = exports.onGetWifiList = exports.onCompassChange = exports.onBluetoothDeviceFound = exports.onBluetoothAdapterStateChange = exports.onBeaconUpdate = exports.onBeaconServiceChange = exports.onBLEConnectionStateChange = exports.onBLECharacteristicValueChange = exports.onAccelerometerChange = exports.notifyBLECharacteristicValueChange = exports.navigateToMiniProgram = exports.navigateTo = exports.navigateBackMiniProgram = exports.navigateBack = exports.makePhoneCall = exports.login = exports.loadFontFace = exports.hideToast = exports.hideTabBarRedDot = exports.hideTabBar = exports.hideShareMenu = exports.hideLoading = exports.getWifiList = exports.getWeRunData = exports.getUserInfo = exports.getSystemInfoSync = exports.getSystemInfo = exports.getStorageInfoSync = exports.getStorageInfo = exports.getStorage = exports.getShareInfo = exports.getSetting = exports.getScreenBrightness = exports.getSavedFileList = exports.getSavedFileInfo = exports.getNetworkType = exports.getLocation = exports.getImageInfo = exports.getHCEState = exports.getFileInfo = exports.getExtConfigSync = exports.getExtConfig = exports.getConnectedWifi = exports.getConnectedBluetoothDevices = exports.getClipboardData = exports.getBluetoothDevices = exports.getBluetoothAdapterState = exports.getBeacons = exports.getBatteryInfoSync = exports.getBatteryInfo = exports.getBackgroundAudioPlayerState = exports.getBLEDeviceServices = exports.getBLEDeviceCharacteristics = exports.getAvailableAudioSources = exports.downloadFile = exports.createBLEConnection = exports.createAnimation = exports.connectWifi = exports.connectSocket = exports.closeSocket = exports.closeBluetoothAdapter = exports.closeBLEConnection = exports.clearStorage = exports.chooseVideo = exports.chooseLocation = exports.chooseInvoiceTitle = exports.chooseImage = exports.chooseAddress = exports.checkSession = exports.checkIsSupportSoterAuthentication = exports.checkIsSoterEnrolledInDevice = exports.canvasToTempFilePath = exports.canvasPutImageData = exports.canvasGetImageData = exports.authorize = exports.addPhoneContact = exports.addCard = exports.Worker = exports.VideoContext = exports.UpdateManager = exports.SocketTask = exports.SelectorQuery = exports.RecorderManager = exports.MapContext = exports.LivePusherContext = exports.LivePlayerContext = exports.InnerAudioContext = exports.CanvasContext = exports.CameraContext = exports.BackgroundAudioManager = exports.AudioContext = exports.Animation = void 0;
exports.writeBLECharacteristicValue = exports.vibrateShort = exports.vibrateLong = exports.uploadFile = exports.updateShareMenu = exports.switchTab = exports.stopWifi = exports.stopHCE = exports.stopCompass = exports.stopBluetoothDevicesDiscovery = exports.stopBeaconDiscovery = exports.stopAccelerometer = exports.startWifi = exports.startSoterAuthentication = exports.startRecord = exports.startPullDownRefresh = exports.startHCE = exports.startCompass = exports.startBluetoothDevicesDiscovery = exports.startBeaconDiscovery = exports.startAccelerometer = exports.showToast = exports.showTabBarRedDot = exports.showTabBar = exports.showShareMenu = exports.showModal = exports.showLoading = exports.showActionSheet = exports.setWifiList = exports.setTopBarText = exports.setTabBarStyle = exports.setTabBarItem = exports.setTabBarBadge = exports.setStorage = exports.setScreenBrightness = exports.setNavigationBarTitle = exports.setNavigationBarColor = exports.setKeepScreenOn = exports.setEnableDebug = exports.setClipboardData = exports.setBackgroundTextStyle = exports.setBackgroundColor = exports.sendSocketMessage = exports.sendHCEMessage = exports.seekBackgroundAudio = exports.scanCode = exports.saveVideoToPhotosAlbum = exports.saveImageToPhotosAlbum = exports.saveFile = exports.requestPayment = exports.request = exports.removeTabBarBadge = exports.removeStorage = exports.removeSavedFile = exports.redirectTo = exports.readBLECharacteristicValue = exports.reLaunch = exports.previewImage = exports.playVoice = exports.playBackgroundAudio = exports.pageScrollTo = exports.openSetting = exports.openLocation = exports.openDocument = void 0;
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var request;
/**
 * 发起网络请求。**使用前请先阅读[说明](https://smartapp.baidu.com/docs/develop/api/net/)**。
 *
 * **返回值：**
 *
 *
 * 返回一个 `requestTask` 对象，通过 `requestTask`，可中断请求任务。
 *
 * **Bug & Tip：**
 *
 * 1.  `tip`: content-export type 默认为 'application/json';
 * 2.  `bug`: 开发者工具 `0.10.102800` 版本，`header` 的 `content-export type` 设置异常；
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.request({
 *       url: 'test.php', //仅为示例，并非真实的接口地址
 *       data: {
 *          x: '' ,
 *          y: ''
 *       },
 *       header: {
 *           'content-export type': 'application/json' // 默认值
 *       },
 *       success: function(res) {
 *         console.log(res.data)
 *       }
 *     })
 *     ```
 *
 * **示例代码：**
 *
 *     ```javascript
 *     const requestTask = swan.request({
 *       url: 'test.php', //仅为示例，并非真实的接口地址
 *       data: {
 *          x: '' ,
 *          y: ''
 *       },
 *       header: {
 *           'content-export type': 'application/json'
 *       },
 *       success: function(res) {
 *         console.log(res.data)
 *       }
 *     })
 *
 *     requestTask.abort() // 取消请求任务
 *     ```
 * 
 */
var uploadFile;
/**
 * 将本地资源上传到开发者服务器，客户端发起一个 HTTPS POST 请求，其中 `content-export type` 为 `multipart/form-data` 。
 *
 * 如页面通过 [swan.chooseImage](https://smartapp.baidu.com/docs/develop/api/media/#chooseImage) 等接口获取到一个本地资源的临时文件路径后，可通过此接口将本地资源上传到指定服务器。
 *
 * **返回值：**
 *
 *
 * 返回一个 `uploadTask` 对象，通过 `uploadTask`，可监听上传进度变化事件，以及取消上传任务。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.chooseImage({
 *       success: function(res) {
 *         var tempFilePaths = res.tempFilePaths
 *         swan.uploadFile({
 *           url: 'https://smartprogram.baidu.com/xxx', // 开发者服务器 url
 *           filePath: tempFilePaths[0],
 *           name: 'file',
 *           formData:{
 *             'user': 'test'
 *           },
 *           success: function(res){
 *             var data = res.data
 *             //do something
 *           }
 *         })
 *       }
 *     })
 *     ```
 *
 * **示例代码：**
 *
 *     ```javascript
 *     const uploadTask = swan.uploadFile({
 *         url: 'https://smartprogram.baidu.com/xxx', // 开发者服务器 url
 *         filePath: tempFilePaths[0],
 *         name: 'file',
 *         formData:{
 *             'user': 'test'
 *         },
 *         success: function(res){
 *             var data = res.data
 *             //do something
 *         }
 *     })
 *
 *     uploadTask.onProgressUpdate((res) => {
 *         console.log('上传进度', res.progress)
 *         console.log('已经上传的数据长度', res.totalBytesSent)
 *         console.log('预期需要上传的数据总长度', res.totalBytesExpectedToSend)
 *     })
 *
 *     uploadTask.abort() // 取消上传任务
 *     ```
 * 
 */
var downloadFile;
/**
 * 下载文件资源到本地，客户端直接发起一个 HTTP GET 请求，返回文件的本地临时路径。
 *
 * **返回值：**
 *
 *
 * 返回一个 `downloadTask` 对象，通过 `downloadTask`，可监听下载进度变化事件，以及取消下载任务。
 *
 * **Tips：**
 *
 * 1. 文件的临时路径，在智能小程序本次启动期间可以正常使用，如需持久保存，需再主动调用 swan.saveFile，才能在智能小程序下次启动时访问得到。
 * 2. 请在 header 中指定合理的 Content-Type 字段，以保证客户端正确处理文件类型  
 * 3. uploadFile 上传文件大小限制为 25M。       
 * 
 * **示例代码：**
 *
 *     ```javascript
 *     swan.downloadFile({
 *       url: 'https://smartprogram.baidu.com/xxx', //仅为示例，并非真实的资源
 *       success: function(res) {
 *         // 只要服务器有响应数据，就会把响应内容写入文件并进入 success 回调，业务需要自行判断是否下载到了想要的内容
 *         if (res.statusCode === 200) {
 *             swan.playVoice({
 *               filePath: res.tempFilePath
 *             })
 *         }
 *       }
 *     })
 *     ```
 *
 * **示例代码：**
 *
 *     ```javascript
 *     const downloadTask = swan.downloadFile({
 *         url: 'https://smartprogram.baidu.com/xxx', //仅为示例，并非真实的资源
 *         success: function(res) {
 *             swan.playVoice({
 *                 filePath: res.tempFilePath
 *             })
 *         }
 *     })
 *
 *     downloadTask.onProgressUpdate((res) => {
 *         console.log('下载进度', res.progress)
 *         console.log('已经下载的数据长度', res.totalBytesWritten)
 *         console.log('预期需要下载的数据总长度', res.totalBytesExpectedToWrite)
 *     })
 *
 *     downloadTask.abort() // 取消下载任务
 *     ```
 * 
 */
var connectSocket;
/**
 * 创建一个 [WebSocket](https://developer.mozilla.org/zh-CN/docs/Web/API/WebSocket) 连接。
 *
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.connectSocket({
 *       url: 'wss://example.baidu.com',
 *       data:{
 *         x: '',
 *         y: ''
 *       },
 *       header:{ 
 *         'content-export type': 'application/json'
 *       },
 *       protocols: ['protocol1'],
 *       method:"GET"
 *     })
 *     ```
 * 
 */
var onSocketOpen;
/**
 * 监听WebSocket连接打开事件。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.connectSocket({
 *       url: 'test.php'
 *     })
 *     swan.onSocketOpen(function(res) {
 *       console.log('WebSocket连接已打开！')
 *     })
 *     ```
 * 
 */
/**
 * 监听WebSocket错误。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.connectSocket({
 *       url: 'test.php'
 *     })
 *     swan.onSocketOpen(function(res){
 *       console.log('WebSocket连接已打开！')
 *     })
 *     swan.onSocketError(function(res){
 *       console.log('WebSocket连接打开失败，请检查！')
 *     })
 *     ```
 * 
 */
var sendSocketMessage;
/**
 * 通过 WebSocket 连接发送数据，需要先 [swan.connectSocket](https://smartapp.baidu.com/docs/develop/api/net/#connectSocket)，并在 [swan.onSocketOpen](https://smartapp.baidu.com/docs/develop/api/net/#onSocketOpen) 回调之后才能发送。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     var socketOpen = false
 *     var socketMsgQueue = []
 *     swan.connectSocket({
 *       url: 'test.php'
 *     })
 *
 *     swan.onSocketOpen(function(res) {
 *       socketOpen = true
 *       for (var i = 0; i < socketMsgQueue.length; i++){
 *          sendSocketMessage(socketMsgQueue[i])
 *       }
 *       socketMsgQueue = []
 *     })
 *
 *     export function sendSocketMessage(msg) {
 *       if (socketOpen) {
 *         swan.sendSocketMessage({
 *           data:msg
 *         })
 *       } else {
 *          socketMsgQueue.push(msg)
 *       }
 *     }
 *     ```
 * 
 */
var onSocketMessage;
/**
 * 监听WebSocket接受到服务器的消息事件。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.connectSocket({
 *       url: 'test.php'
 *     })
 *
 *     swan.onSocketMessage(function(res) {
 *       console.log('收到服务器内容：' + res.data)
 *     })
 *     ```
 * 
 */
var closeSocket;
/**
 * 关闭 WebSocket 连接。
 * 
 */
/**
 * 监听WebSocket关闭。
 *
 * **返回值：**
 *
 *
 * 返回一个SocketTask
 *
 *
 *
 * **示例：**
 *
 *     ```javascript
 *     swan.connectSocket({
 *       url: 'test.php'
 *     })
 *
 *     //注意这里有时序问题，
 *     //如果 swan.connectSocket 还没回调 swan.onSocketOpen，而先调用 swan.closeSocket，那么就做不到关闭 WebSocket 的目的。
 *     //必须在 WebSocket 打开期间调用 swan.closeSocket 才能关闭。
 *     swan.onSocketOpen(function() {
 *       swan.closeSocket()
 *     })
 *
 *     swan.onSocketClose(function(res) {
 *       console.log('WebSocket 已关闭！')
 *     })
 *     ```
 * 
 */
/**
 *
 * WebSocket 任务，可通过 swan.connectSocket()接口创建返回。
 */
var SocketTask = exports.SocketTask = /*#__PURE__*/(0, _createClass2.default)(function SocketTask() {
  (0, _classCallCheck2.default)(this, SocketTask);
});
var chooseImage;
/**
 * 从本地相册选择图片或使用相机拍照。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.chooseImage({
 *       count: 1, // 默认9
 *       sizeType: ['original', 'compressed'], // 可以指定是原图还是压缩图，默认二者都有
 *       sourceType: ['album', 'camera'], // 可以指定来源是相册还是相机，默认二者都有
 *       success: export function (res) {
 *         // 返回选定照片的本地文件路径列表，tempFilePath可以作为img标签的src属性显示图片
 *         var tempFilePaths = res.tempFilePaths
 *       }
 *     })
 *     ```
 */
var previewImage;
/**
 * 预览图片。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.previewImage({
 *       current: '', // 当前显示图片的http链接
 *       urls: [] // 需要预览的图片http链接列表
 *     })
 *     ```
 * 
 */
var getImageInfo;
/**
 * 获取图片信息
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.getImageInfo({
 *       src: 'images/a.jpg',
 *       success: export function (res) {
 *         console.log(res.width)
 *         console.log(res.height)
 *       }
 *     })
 *
 *     swan.chooseImage({
 *       success: export function (res) {
 *         swan.getImageInfo({
 *           src: res.tempFilePaths[0],
 *           success: export function (res) {
 *             console.log(res.width)
 *             console.log(res.height)
 *           }
 *         })
 *       }
 *     })
 *     ```
 * 
 */
var saveImageToPhotosAlbum;
/**
 * 保存图片到系统相册。需要用户授权scope.writePhotosAlbum
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.saveImageToPhotosAlbum({
 *         success(res) {
 *         }
 *     })
 *     ```
 */
var startRecord;
/**
 * **注意：1.6.0 版本开始，本接口不再维护。建议使用能力更强的swan.getRecorderManager接口**
 *
 * 开始录音。当主动调用`swan.stopRecord`，或者录音超过1分钟时自动结束录音，返回录音文件的临时文件路径。当用户离开小程序时，此接口无法调用。
 *
 * 需要用户授权scope.record
 * 
 */
/**
 * 主动调用停止录音。
 * **示例代码：**
 *
 *     ```javascript
 *     swan.startRecord({
 *       success: function(res) {
 *         var tempFilePath = res.tempFilePath 
 *       },
 *       fail: function(res) {
 *          //录音失败
 *       }
 *     })
 *     setTimeout(function() {
 *       //结束录音  
 *       swan.stopRecord()
 *     }, 10000)
 *     ```
 * 
 */
/**
 * 
 *
 * 获取**全局唯一**的录音管理器 `recorderManager`。
 *
 * **其中，采样率和码率有一定要求，具体有效值如下：：**
 *
 *   采样率  |  编码码率         
 * ----------|-------------------
 *   8000    |  16000 ~ 48000    
 *   11025   |  16000 ~ 48000    
 *   12000   |  24000 ~ 64000    
 *   16000   |  24000 ~ 96000    
 *   22050   |  32000 ~ 128000   
 *   24000   |  32000 ~ 128000   
 *   32000   |  48000 ~ 192000   
 *   44100   |  64000 ~ 320000   
 *   48000   |  64000 ~ 320000   
 *
 * audioSource 有效值：
 *
 * **示例代码：**
 *
 *     ```javascript
 *     const recorderManager = swan.getRecorderManager()
 *
 *     recorderManager.onStart(() => {
 *       console.log('recorder start')
 *     })
 *     recorderManager.onPause(() => {
 *       console.log('recorder pause')
 *     })
 *     recorderManager.onStop((res) => {
 *       console.log('recorder stop', res)
 *       const { tempFilePath } = res
 *     })
 *     recorderManager.onFrameRecorded((res) => {
 *       const { frameBuffer } = res
 *       console.log('frameBuffer.byteLength', frameBuffer.byteLength)
 *     })
 *
 *     const options = {
 *       duration: 10000,
 *       sampleRate: 44100,
 *       numberOfChannels: 1,
 *       encodeBitRate: 192000,
 *       format: 'aac',
 *       frameSize: 50
 *     }
 *
 *     recorderManager.start(options)
 *     ```
 * 
 */
var RecorderManager = exports.RecorderManager = /*#__PURE__*/(0, _createClass2.default)(function RecorderManager() {
  (0, _classCallCheck2.default)(this, RecorderManager);
});
var playVoice;
/**
 * **注意：1.6.0 版本开始，本接口不再维护。建议使用能力更强的 [swan.createInnerAudioContext]接口**
 *
 * 开始播放语音，同时只允许一个语音文件正在播放，如果前一个语音文件还没播放完，将中断前一个语音播放。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.startRecord({
 *       success: function(res) {
 *         var tempFilePath = res.tempFilePath
 *         swan.playVoice({
 *           filePath: tempFilePath,
 *           complete: function(){
 *           }
 *         })
 *       }
 *     })
 *     ```
 * 
 */
/**
 * 暂停正在播放的语音。再次调用swan.playVoice播放同一个文件时，会从暂停处开始播放。如果想从头开始播放，需要先调用 swan.stopVoice。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.startRecord({
 *       success: function(res) {
 *         var tempFilePath = res.tempFilePath
 *           swan.playVoice({
 *           filePath: tempFilePath
 *         })
 *
 *         setTimeout(function() {
 *             //暂停播放
 *           swan.pauseVoice()
 *         }, 5000)
 *       }
 *     })
 *     ```
 * 
 */
/**
 * 结束播放语音。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.startRecord({
 *       success: function(res) {
 *         var tempFilePath = res.tempFilePath
 *         swan.playVoice({
 *           filePath:tempFilePath
 *         })
 *
 *         setTimeout(function(){
 *           swan.stopVoice()
 *         }, 5000)
 *       }
 *     })
 *     ```
 * 
 */
var getBackgroundAudioPlayerState;
/**
 * **注意：1.2.0 版本开始，本接口不再维护。建议使用能力更强的 swan.getBackgroundAudioManager接口**
 *
 * 获取后台音乐播放状态。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.getBackgroundAudioPlayerState({
 *         success: function(res) {
 *             var status = res.status
 *             var dataUrl = res.dataUrl
 *             var currentPosition = res.currentPosition
 *             var duration = res.duration
 *             var downloadPercent = res.downloadPercent
 *         }
 *     })
 *     ```
 * 
 */
var playBackgroundAudio;
/**
 * 使用后台播放器播放音乐，对于客户端来说，只能同时有一个后台音乐在播放。当用户离开小程序后，音乐将暂停播放；当用户点击“显示在聊天顶部”时，音乐不会暂停播放；当用户在其他小程序占用了音乐播放器，原有小程序内的音乐将停止播放。
 *
 * **OBJECT参数说明：**
 *
 *     ```javascript
 *     swan.playBackgroundAudio({
 *         dataUrl: '',
 *         title: '',
 *         coverImgUrl: ''
 *     })
 *     ```
 * 
 */
/**
 * 暂停播放音乐。
 *
 * **示例代码**
 *
 * **示例：**
 *
 *     ```javascript
 *     swan.pauseBackgroundAudio()
 *     ```
 * 
 */
var seekBackgroundAudio;
/**
 * 控制音乐播放进度。
 *
 * **OBJECT参数说明：**
 *
 *     ```javascript
 *     swan.seekBackgroundAudio({
 *         position: 30
 *     })
 *     ```
 */
/**
 * 停止播放音乐。
 *
 * **示例代码**
 *
 * **示例：**
 *
 *     ```javascript
 *     swan.stopBackgroundAudio()
 *     ```
 * 
 */
/**
 * 监听音乐播放。
 * 
 */
/**
 * 监听音乐暂停。
 * 
 */
/**
 * 监听音乐停止。
 *
 * **bug & tip：**
 *
 * 1.  `bug`: `iOS` `6.3.30` swan.seekBackgroundAudio 会有短暂延迟
 * 
 */
/**
 * 
 *
 * 获取**全局唯一**的背景音频管理器 `backgroundAudioManager`。
 *
 * **errcode 说明：**
 *
 *   errCode   |  说明   
 * ------------|---------
 *   10001     | 系统错误
 *   10002     | 网络错误
 *   10003     | 文件错误
 *   10004     | 格式错误
 *   -1        | 未知错误
 *
 * **示例代码：**
 *
 *     ```javascript
 *     const backgroundAudioManager = swan.getBackgroundAudioManager()
 *
 *     backgroundAudioManager.title = '此时此刻'
 *     backgroundAudioManager.epname = '此时此刻'
 *     backgroundAudioManager.singer = '许巍'
 *     backgroundAudioManager.coverImgUrl = 'http://y.gtimg.cn/music/photo_new/T002R300x300M000003rsKF44GyaSk.jpg?max_age=2592000'
 *     backgroundAudioManager.src = 'http://ws.stream.qqmusic.qq.com/M500001VfvsJ21xFqb.mp3?guid=ffffffff82def4af4b12b3cd9337d5e7&uin=346897220&vkey=6292F51E1E384E061FF02C31F716658E5C81F5594D561F2E88B854E81CAAB7806D5E4F103E55D33C16F3FAC506D1AB172DE8600B37E43FAD&fromtag=46' // 设置了 src 之后会自动播放
 *     ```
 * 
 */
var BackgroundAudioManager = exports.BackgroundAudioManager = /*#__PURE__*/(0, _createClass2.default)(function BackgroundAudioManager() {
  (0, _classCallCheck2.default)(this, BackgroundAudioManager);
});
/**
 * **注意：1.6.0 版本开始，本接口不再维护。建议使用能力更强的 [swan.createInnerAudioContext]() 接口**
 *
 * 创建并返回 audio 上下文 `audioContext` 对象。在自定义组件下，第二个参数传入组件实例this，以操作组件内 `<audio/>` 组件
 *
 * **audioContext：**
 *
 * `audioContext` 通过 audioId 跟一个 `<audio/>` 组件绑定，通过它可以操作对应的 `<audio/>` 组件。
 *
 * **示例代码：**
 *
 *     ```html
 *     <!-- audio.swan -->
 *     <audio  src="{{src}}" id="myAudio" ></audio>
 *
 *     <button export type="primary" bindtap="audioPlay">播放</button>
 *     <button export type="primary" bindtap="audioPause">暂停</button>
 *     <button export type="primary" bindtap="audio14">设置当前播放时间为14秒</button>
 *     <button export type="primary" bindtap="audioStart">回到开头</button>
 *     ```
 *
 * **示例代码：**
 *
 *     ```javascript
 *     // audio.js
 *     Page({
 *       onReady: export function (e) {
 *         // 使用 swan.createAudioContext 获取 audio 上下文 context
 *         this.audioCtx = swan.createAudioContext('myAudio')
 *         this.audioCtx.setSrc('http://ws.stream.qqmusic.qq.com/M500001VfvsJ21xFqb.mp3?guid=ffffffff82def4af4b12b3cd9337d5e7&uin=346897220&vkey=6292F51E1E384E06DCBDC9AB7C49FD713D632D313AC4858BACB8DDD29067D3C601481D36E62053BF8DFEAF74C0A5CCFADD6471160CAF3E6A&fromtag=46')
 *         this.audioCtx.play()
 *       },
 *       data: {
 *         src: ''
 *       },
 *       audioPlay: export function () {
 *         this.audioCtx.play()
 *       },
 *       audioPause: export function () {
 *         this.audioCtx.pause()
 *       },
 *       audio14: export function () {
 *         this.audioCtx.seek(14)
 *       },
 *       audioStart: export function () {
 *         this.audioCtx.seek(0)
 *       }
 *     })
 *     ```
 * 
 */
var AudioContext = exports.AudioContext = /*#__PURE__*/(0, _createClass2.default)(function AudioContext() {
  (0, _classCallCheck2.default)(this, AudioContext);
});
/**
 * 
 *
 * 创建并返回内部 audio 上下文 `innerAudioContext` 对象。_本接口是 `swan.createAudioContext` 升级版。_
 *
 * **errCode 说明：**
 *
 *   errCode   |  说明   
 * ------------|---------
 *   10001     | 系统错误
 *   10002     | 网络错误
 *   10003     | 文件错误
 *   10004     | 格式错误
 *   -1        | 未知错误
 *
 * **示例代码：**
 *
 *     ```javascript
 *     const innerAudioContext = swan.createInnerAudioContext()
 *     innerAudioContext.autoplay = true
 *     innerAudioContext.src = 'http://ws.stream.qqmusic.qq.com/M500001VfvsJ21xFqb.mp3?guid=ffffffff82def4af4b12b3cd9337d5e7&uin=346897220&vkey=6292F51E1E384E061FF02C31F716658E5C81F5594D561F2E88B854E81CAAB7806D5E4F103E55D33C16F3FAC506D1AB172DE8600B37E43FAD&fromtag=46'
 *     innerAudioContext.onPlay(() => {
 *         console.log('开始播放')
 *     })
 *     innerAudioContext.onError((res) => {
 *         console.log(res.errMsg)
 *         console.log(res.errCode)
 *     })
 *     ```
 * 
 */
var InnerAudioContext = exports.InnerAudioContext = /*#__PURE__*/(0, _createClass2.default)(function InnerAudioContext() {
  (0, _classCallCheck2.default)(this, InnerAudioContext);
});
var getAvailableAudioSources;
/**
 * 
 *
 * **audioSource 有效值：：**
 *
 *   值           |  说明                              |  支持平台               
 * ---------------|------------------------------------|-------------------------
 *   auto         |自动设置，默认使用手机麦克风，插上耳麦后自动切换使用耳机麦克风|  iOS/Android/devtools   
 *   buildInMic   |  手机麦克风                        |  iOS                    
 *   headsetMic   |  耳机麦克风                        |  iOS                    
 *   mic          |麦克风（没插耳麦时是手机麦克风，插耳麦时是耳机麦克风|  Android                
 *   camcorder    |  摄像头的麦克风                    |  Android                
 * 
 */
var chooseVideo;
/**
 * 拍摄视频或从手机相册中选视频，返回视频的临时文件路径。
 *
 * **示例代码：**
 *
 *     ```html
 *     <view class="container">
 *         <video src="{{src}}"></video>
 *         <button bindtap="bindButtonTap">获取视频</button>
 *     </view>
 *     ```
 *
 * **示例代码：**
 *
 *     ```javascript
 *     Page({
 *         bindButtonTap: function() {
 *             var that = this
 *             swan.chooseVideo({
 *                 sourceType: ['album','camera'],
 *                 maxDuration: 60,
 *           camera: 'back',
 *                 success: function(res) {
 *                     that.setData({
 *                         src: res.tempFilePath
 *                     })
 *                 }
 *             })
 *         }
 *     })
 *     ```
 * 
 */
var saveVideoToPhotosAlbum;
/**
 * 
 *
 * 保存视频到系统相册。需要用户授权 scope.writePhotosAlbum
 *
 * **Bug & Tip：**
 *
 * 1.  `tip`: camera 参数在部分 Android 手机下由于系统 ROM 不支持无法生效
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.saveVideoToPhotosAlbum({
 *       filePath: 'swanfile://xxx'
 *       success(res) {
 *         console.log(res.errMsg)
 *       }
 *     })
 *     ```
 * 
 */
/**
 * 创建并返回 video 上下文 `videoContext` 对象。在自定义组件下，第二个参数传入组件实例this，以操作组件内 `<video/>` 组件
 *
 * **videoContext：**
 *
 * `videoContext` 通过 videoId 跟一个 video 组件绑定，通过它可以操作一个 video 组件。
 *
 * **示例代码：**
 *
 *     ```html
 *     <view class="section tc">
 *       <video id="myVideo" src="http://wxsnsdy.tc.qq.com/105/20210/snsdyvideodownload?filekey=30280201010421301f0201690402534804102ca905ce620b1241b726bc41dcff44e00204012882540400&bizid=1023&hy=SH&fileparam=302c020101042530230204136ffd93020457e3c4ff02024ef202031e8d7f02030f42400204045a320a0201000400"   enable-danmu danmu-btn controls></video>
 *       <view class="btn-area">
 *         <input bindblur="bindInputBlur"/>
 *         <button bindtap="bindSendDanmu">发送弹幕</button>
 *       </view>
 *     </view>
 *     ```
 *
 * **示例代码：**
 *
 *     ```javascript
 *     export function getRandomColor () {
 *       let rgb = []
 *       for (let i = 0 ; i < 3; ++i){
 *         let color = Math.floor(Math.random() * 256).toString(16)
 *         color = color.length == 1 ? '0' + color : color
 *         rgb.push(color)
 *       }
 *       return '#' + rgb.join('')
 *     }
 *
 *     Page({
 *       onReady: export function (res) {
 *         this.videoContext = swan.createVideoContext('myVideo')
 *       },
 *       inputValue: '',
 *       bindInputBlur: function(e) {
 *         this.inputValue = e.detail.value
 *       },
 *       bindSendDanmu: export function () {
 *         this.videoContext.sendDanmu({
 *           text: this.inputValue,
 *           color: getRandomColor()
 *         })
 *       }
 *     })
 *     ```
 * 
 */
var VideoContext = exports.VideoContext = /*#__PURE__*/(0, _createClass2.default)(function VideoContext() {
  (0, _classCallCheck2.default)(this, VideoContext);
});
/**
 * 
 *
 * 创建并返回 camera 上下文 `cameraContext` 对象，`cameraContext` 与页面的 `camera` 组件绑定，一个页面只能有一个camera，通过它可以操作对应的 `<camera/>` 组件。 在自定义组件下，第一个参数传入组件实例this，以操作组件内 `<camera/>` 组件
 *
 * **示例代码：**
 *
 * 在开发者工具中预览效果
 * 
 */
var CameraContext = exports.CameraContext = /*#__PURE__*/(0, _createClass2.default)(function CameraContext() {
  (0, _classCallCheck2.default)(this, CameraContext);
});
/**
 * 
 *
 * 操作对应的 `<live-player/>` 组件。 创建并返回 `live-player` 上下文 `LivePlayerContext` 对象。在自定义组件下，第二个参数传入组件实例this，以操作组件内 `<live-player/>` 组件
 *
 * **示例代码：**
 *
 * 在开发者工具中预览效果
 * 
 */
var LivePlayerContext = exports.LivePlayerContext = /*#__PURE__*/(0, _createClass2.default)(function LivePlayerContext() {
  (0, _classCallCheck2.default)(this, LivePlayerContext);
});
/**
 * 
 *
 * 创建并返回 `live-pusher` 上下文 `LivePusherContext` 对象，`LivePusherContext` 与页面的 `<live-pusher />` 组件绑定，一个页面只能有一个 `live-pusher`，通过它可以操作对应的 `<live-pusher/>` 组件。 在自定义组件下，第一个参数传入组件实例this，以操作组件内 `<live-pusher/>` 组件
 *
 * **示例代码：**
 *
 * 在开发者工具中预览效果
 * 
 */
var LivePusherContext = exports.LivePusherContext = /*#__PURE__*/(0, _createClass2.default)(function LivePusherContext() {
  (0, _classCallCheck2.default)(this, LivePusherContext);
});
var loadFontFace;
/**
 * 
 *
 * 动态加载网络字体
 *
 * **Tip：**
 *
 * 1.  引入的外部字体资源，建议格式为TTF和WOFF，WOFF2在低版本的IOS上会不兼容。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.loadFontFace({
 *       family: 'Bitstream Vera Serif Bold',
 *       source: 'url("http://developer.mozilla.org/@api/deki/files/2934/=VeraSeBd.ttf")',
 *       success: function(res) {
 *         console.log(res.status) //  loaded
 *       },
 *       fail: function(res) {
 *         console.log(res.status) //  error
 *       },
 *       complete: function(res) {
 *         console.log(res.status);
 *       }
 *     });
 *     ```
 * 
 */
var saveFile;
/**
 * 保存文件到本地。**注意：saveFile 会把临时文件移动，因此调用成功后传入的 tempFilePath 将不可用**
 *
 * **bug & tip：**
 *
 * 1.  `tip`: 本地文件存储的大小限制为 10M
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.chooseImage({
 *       success: function(res) {
 *         var tempFilePaths = res.tempFilePaths
 *         swan.saveFile({
 *           tempFilePath: tempFilePaths[0],
 *           success: function(res) {
 *             var savedFilePath = res.savedFilePath
 *           }
 *         })
 *       }
 *     })
 *     ```
 * 
 */
var getSavedFileList;
/**
 * 获取本地已保存的文件列表
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.getSavedFileList({
 *       success: function(res) {
 *         console.log(res.fileList)
 *       }
 *     })
 *     ```
 * 
 */
var getSavedFileInfo;
/**
 * 获取本地文件的文件信息。此接口只能用于获取已保存到本地的文件，若需要获取临时文件信息，请使用 [swan.getFileInfo]() 接口。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.getSavedFileInfo({
 *       filePath: 'swanfile://somefile', //仅做示例用，非真正的文件路径
 *       success: function(res) {
 *         console.log(res.size)
 *         console.log(res.createTime)
 *       }
 *     })
 *     ```
 * 
 */
var removeSavedFile;
/**
 * 删除本地存储的文件
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.getSavedFileList({
 *       success: function(res) {
 *         if (res.fileList.length > 0){
 *           swan.removeSavedFile({
 *             filePath: res.fileList[0].filePath,
 *             complete: function(res) {
 *               console.log(res)
 *             }
 *           })
 *         }
 *       }
 *     })
 *     ```
 * 
 */
var openDocument;
/**
 * 新开页面打开文档，支持格式：doc, xls, ppt, pdf, docx, xlsx, pptx
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.downloadFile({
 *       url: 'http://example.com/somefile.pdf',
 *       success: export function (res) {
 *         var filePath = res.tempFilePath
 *         swan.openDocument({
 *           filePath: filePath,
 *           success: export function (res) {
 *             console.log('打开文档成功')
 *           }
 *         })
 *       }
 *     })
 *     ```
 * 
 */
var getFileInfo;
/**
 * 
 *
 * 获取文件信息
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.getFileInfo({
 *         success(res) {
 *             console.log(res.size)
 *             console.log(res.digest)
 *         }
 *     })
 *     ```
 * 
 */
var setStorage;
/**
 * 将数据存储在本地缓存中指定的 key 中，会覆盖掉原来该 key 对应的内容，这是一个异步接口。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.setStorage({
 *       key:"key",
 *       data:"value"
 *     })
 *     ```
 * 
 */
/**
 * 将 data 存储在本地缓存中指定的 key 中，会覆盖掉原来该 key 对应的内容，这是一个同步接口。
 *
 * **参数说明：**
 *
 *     ```javascript
 *     try {
 *         swan.setStorageSync('key', 'value')
 *     } catch (e) {    
 *     }
 *     ```
 * 
 */
var getStorage;
/**
 * 从本地缓存中异步获取指定 key 对应的内容。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.getStorage({
 *       key: 'key',
 *       success: function(res) {
 *           console.log(res.data)
 *       } 
 *     })
 *     ```
 * 
 */
/**
 * 从本地缓存中同步获取指定 key 对应的内容。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     try {
 *       var value = swan.getStorageSync('key')
 *       if (value) {
 *           // Do something with return value
 *       }
 *     } catch (e) {
 *       // Do something when catch error
 *     }
 *     ```
 * 
 */
var getStorageInfo;
/**
 * 异步获取当前storage的相关信息
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.getStorageInfo({
 *       success: function(res) {
 *         console.log(res.keys)
 *         console.log(res.currentSize)
 *         console.log(res.limitSize)
 *       }
 *     })
 *     ```
 * 
 */
var getStorageInfoSync;
/**
 * 同步获取当前storage的相关信息
 *
 * **示例代码：**
 *
 *     ```javascript
 *     try {
 *       var res = swan.getStorageInfoSync()
 *       console.log(res.keys)
 *       console.log(res.currentSize)
 *       console.log(res.limitSize)
 *     } catch (e) {
 *       // Do something when catch error
 *     }
 *     ```
 * 
 */
var removeStorage;
/**
 * 从本地缓存中异步移除指定 key 。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.removeStorage({
 *       key: 'key',
 *       success: function(res) {
 *         console.log(res.data)
 *       } 
 *     })
 *     ```
 * 
 */
/**
 * 从本地缓存中同步移除指定 key 。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     try {
 *       swan.removeStorageSync('key')
 *     } catch (e) {
 *       // Do something when catch error
 *     }
 *     ```
 * 
 */
var clearStorage;
/**
 * 清理本地数据缓存。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.clearStorage()
 *     ```
 * 
 */
/**
 * 同步清理本地数据缓存
 *
 * **Bug & Tip：**
 *
 * 1.  `tip`: 本地数据存储的大小限制为 10MB
 *
 * **示例代码：**
 *
 *     ```javascript
 *     try {
 *         swan.clearStorageSync()
 *     } catch(e) {
 *       // Do something when catch error
 *     }
 *     ```
 * 
 */
var getLocation;
/**
 * 获取当前的地理位置、速度。当用户离开小程序后，此接口无法调用；当用户点击“显示在聊天顶部”时，此接口可继续调用。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.getLocation({
 *       export type: 'wgs84',
 *       success: function(res) {
 *         var latitude = res.latitude
 *         var longitude = res.longitude
 *         var speed = res.speed
 *         var accuracy = res.accuracy
 *       }
 *     })
 *     ```
 * 
 */
var chooseLocation;
/**
 * 打开地图选择位置。
 *
 * 需要用户授权scope.userLocation
 * 
 */
var openLocation;
/**
 * 使用内置地图查看位置。
 *
 * 需要用户授权scope.userLocation
 *
 * **Bug & Tip：**
 *
 * 1.  `bug`: `iOS` `6.3.30` export type 参数不生效，只会返回 wgs84 类型的坐标信息
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.getLocation({
 *       export type: 'gcj02', //返回可以用于swan.openLocation的经纬度
 *       success: function(res) {
 *         var latitude = res.latitude
 *         var longitude = res.longitude
 *         swan.openLocation({
 *           latitude: latitude,
 *           longitude: longitude,
 *           scale: 28
 *         })
 *       }
 *     })
 *     ```
 * 
 */
/**
 * 创建并返回 map 上下文 `mapContext` 对象。在自定义组件下，第二个参数传入组件实例this，以操作组件内 `<map/>` 组件
 *
 * **mapContext：**
 *
 * `mapContext` 通过 mapId 跟一个 `<map/>` 组件绑定，通过它可以操作对应的 `<map/>` 组件。
 *
 * **示例代码：**
 *
 *     ```html
 *     <!-- map.swan -->
 *     <map id="myMap" show-location />
 *
 *     <button export type="primary" bindtap="getCenterLocation">获取位置</button>
 *     <button export type="primary" bindtap="moveToLocation">移动位置</button>
 *     <button export type="primary" bindtap="translateMarker">移动标注</button>
 *     <button export type="primary" bindtap="includePoints">缩放视野展示所有经纬度</button>
 *     ```
 *
 * **示例代码：**
 *
 *     ```javascript
 *     // map.js
 *     Page({
 *       onReady: export function (e) {
 *         // 使用 swan.createMapContext 获取 map 上下文
 *         this.mapCtx = swan.createMapContext('myMap')
 *       },
 *       getCenterLocation: export function () {
 *         this.mapCtx.getCenterLocation({
 *           success: function(res){
 *             console.log(res.longitude)
 *             console.log(res.latitude)
 *           }
 *         })
 *       },
 *       moveToLocation: export function () {
 *         this.mapCtx.moveToLocation()
 *       },
 *       translateMarker: function() {
 *         this.mapCtx.translateMarker({
 *           markerId: 0,
 *           autoRotate: true,
 *           duration: 1000,
 *           destination: {
 *             latitude:23.10229,
 *             longitude:113.3345211,
 *           },
 *           animationEnd() {
 *             console.log('animation end')
 *           }
 *         })
 *       },
 *       includePoints: function() {
 *         this.mapCtx.includePoints({
 *           padding: [10],
 *           points: [{
 *             latitude:23.10229,
 *             longitude:113.3345211,
 *           }, {
 *             latitude:23.00229,
 *             longitude:113.3345211,
 *           }]
 *         })
 *       }
 *     })
 *     ```
 * 
 */
var MapContext = exports.MapContext = /*#__PURE__*/(0, _createClass2.default)(function MapContext() {
  (0, _classCallCheck2.default)(this, MapContext);
});
var getSystemInfo;
/**
 * 获取系统信息。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.getSystemInfo({
 *       success: function(res) {
 *         console.log(res.model)
 *         console.log(res.pixelRatio)
 *         console.log(res.windowWidth)
 *         console.log(res.windowHeight)
 *         console.log(res.language)
 *         console.log(res.version)
 *         console.log(res.platform)
 *       }
 *     })
 *     ```
 * 
 */
var getSystemInfoSync;
/**
 * 获取系统信息同步接口
 *
 * **示例代码：**
 *
 *     ```javascript
 *     try {
 *       var res = swan.getSystemInfoSync()
 *       console.log(res.model)
 *       console.log(res.pixelRatio)
 *       console.log(res.windowWidth)
 *       console.log(res.windowHeight)
 *       console.log(res.language)
 *       console.log(res.version)
 *       console.log(res.platform)
 *     } catch (e) {
 *       // Do something when catch error
 *     }
 *     ```
 * 
 */
/**
 *
 * 判断小程序的API，回调，参数，组件等是否在当前版本可用。
 *
 * **String参数说明：** 使用`${API}.${method}.${param}.${options}`或者`${component}.${attribute}.${option}`方式来调用，例如：
 *
 * *   `${API}` 代表 API 名字
 * *   `${method}` 代表调用方式，有效值为`return`, `success`, `object`, `callback`
 * *   `${param}` 代表参数或者返回值
 * *   `${options}` 代表参数的可选值
 * *   `${component}` 代表组件名字
 * *   `${attribute}` 代表组件属性
 * *   `${option}` 代表组件属性的可选值
 *
 * 例子：
 *
 * **示例：**
 *
 *     ```js
 *     swan.canIUse('openBluetoothAdapter')
 *     swan.canIUse('getSystemInfoSync.return.screenWidth')
 *     swan.canIUse('getSystemInfo.success.screenWidth')
 *     swan.canIUse('showToast.object.image')
 *     swan.canIUse('onCompassChange.callback.direction')
 *     swan.canIUse('request.object.method.GET')
 *
 *     swan.canIUse('live-player')
 *     swan.canIUse('text.selectable')
 *     swan.canIUse('button.open-export type.contact')
 *     ```
 * 
 */
var onMemoryWarning;
/**
 * 
 *
 * 监听内存不足的告警事件，Android下有告警等级划分，只有LOW和CRITICAL会回调开发者；iOS无等级划分。
 *
 * **CALLBACK返回参数：**
 *
 *     ```
 *     TRIM_MEMORY_RUNNING_MODERATE = 5
 *     TRIM_MEMORY_RUNNING_LOW = 10
 *     TRIM_MEMORY_RUNNING_CRITICAL = 15
 *     ```
 *
 * **示例代码：**
 *
 *     ```
 *     swan.onMemoryWarning(export function () {
 *       console.log('onMemoryWarningReceive')
 *     })
 *     ```
 * 
 */
var getNetworkType;
/**
 * 获取网络类型。
 *
 * **success返回参数说明：**
 *
 *     ```javascript
 *     swan.getNetworkType({
 *       success: function(res) {
 *         // 返回网络类型, 有效值：
 *         // wifi/2g/3g/4g/unknown(Android下不常见的网络类型)/none(无网络)
 *         var networkType = res.networkType
 *       }
 *     })
 *     ```
 * 
 */
var onNetworkStatusChange;
/**
 * 
 *
 * 监听网络状态变化。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.onNetworkStatusChange(function(res) {
 *       console.log(res.isConnected)
 *       console.log(res.networkType)
 *     })
 *     ```
 * 
 */
var setScreenBrightness;
/**
 * 
 *
 * 设置屏幕亮度。
 * 
 */
var getScreenBrightness;
/**
 * 
 *
 * 获取屏幕亮度。
 * 
 */
var vibrateLong;
/**
 * 
 *
 * 使手机发生较长时间的振动（400ms）
 * 
 */
var vibrateShort;
/**
 * 
 *
 * 使手机发生较短时间的振动（15ms）
 *
 * **Bug & Tip：**
 *
 * 1.  `tip`：`vibrateShort` 接口仅在 iPhone7/iPhone7Plus 及 Android 机型生效
 * 2.  `tip`: `getScreenBrightness` 接口若安卓系统设置中开启了自动调节亮度功能，则屏幕亮度会根据光线自动调整，该接口仅能获取自动调节亮度之前的值，而非实时的亮度值。
 * 
 */
var onAccelerometerChange;
/**
 * 监听加速度数据，频率：5次/秒，接口调用后会自动开始监听，可使用 `swan.stopAccelerometer` 停止监听。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.onAccelerometerChange(function(res) {
 *       console.log(res.x)
 *       console.log(res.y)
 *       console.log(res.z)
 *     })
 *     ```
 * 
 */
var startAccelerometer;
/**
 * 
 *
 * 开始监听加速度数据。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.startAccelerometer({
 *         interval: 'game'
 *     })
 *     ```
 * 
 */
var stopAccelerometer;
/**
 * 
 *
 * 停止监听加速度数据。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.stopAccelerometer()
 *     ```
 * 
 */
var onCompassChange;
/**
 * 监听罗盘数据，频率：5次/秒，接口调用后会自动开始监听，可使用`swan.stopCompass`停止监听。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.onCompassChange(export function (res) {
 *       console.log(res.direction)
 *     })
 *     ```
 * 
 */
var startCompass;
/**
 * 
 *
 * 开始监听罗盘数据。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.startCompass()
 *     ```
 * 
 */
var stopCompass;
/**
 * 
 *
 * 停止监听罗盘数据。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.stopCompass()
 *     ```
 * 
 */
var makePhoneCall;
/**
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.makePhoneCall({
 *       phoneNumber: '1340000' //仅为示例，并非真实的电话号码
 *     })
 *     ```
 * 
 */
var scanCode;
/**
 * 调起客户端扫码界面，扫码成功后返回对应的结果
 *
 * **示例代码：**
 *
 *     ```javascript
 *     // 允许从相机和相册扫码
 *     swan.scanCode({
 *       success: (res) => {
 *         console.log(res)
 *       }
 *     })
 *
 *     // 只允许从相机扫码
 *     swan.scanCode({
 *       onlyFromCamera: true,
 *       success: (res) => {
 *         console.log(res)
 *       }
 *     })
 *     ```
 * 
 */
var setClipboardData;
/**
 * 
 *
 * 设置系统剪贴板的内容
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.setClipboardData({
 *       data: 'data',
 *       success: function(res) {
 *         swan.getClipboardData({
 *           success: function(res) {
 *             console.log(res.data) // data
 *           }
 *         })
 *       }
 *     })
 *     ```
 * 
 */
var getClipboardData;
/**
 * 
 *
 * 获取系统剪贴板内容
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.getClipboardData({
 *       success: function(res){
 *         console.log(res.data)
 *       }
 *     })
 *     ```
 * 
 */
var openBluetoothAdapter;
/**
 * 
 *
 * 初始化小程序蓝牙模块，生效周期为调用`swan.openBluetoothAdapter`至调用`swan.closeBluetoothAdapter`或小程序被销毁为止。 在小程序蓝牙适配器模块生效期间，开发者可以正常调用下面的小程序API，并会收到蓝牙模块相关的on回调。
 *
 * **Bug & Tip：**
 *
 * 2.  `tip`: 在没有调用`swan.openBluetoothAdapter`的情况下调用小程序其它蓝牙模块相关API，API会返回错误，错误码为`10000`
 * 3.  `bug`: 在用户蓝牙开关未开启或者手机不支持蓝牙功能的情况下，调用`swan.openBluetoothAdapter`会返回错误，错误码为`10001`，表示手机蓝牙功能不可用；此时小程序蓝牙模块已经初始化完成，可通过`swan.onBluetoothAdapterStateChange`监听手机蓝牙状态的改变，也可以调用蓝牙模块的所有API。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.openBluetoothAdapter({
 *       success: export function (res) {
 *         console.log(res)
 *       }
 *     })
 *     ```
 * 
 */
var closeBluetoothAdapter;
/**
 * 
 *
 * 关闭蓝牙模块，使其进入未初始化状态。调用该方法将断开所有已建立的链接并释放系统资源。建议在使用小程序蓝牙流程后调用，与`swan.openBluetoothAdapter`成对调用。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.closeBluetoothAdapter({
 *       success: export function (res) {
 *         console.log(res)
 *       }
 *     })
 *     ```
 * 
 */
var getBluetoothAdapterState;
/**
 * 
 *
 * 获取本机蓝牙适配器状态
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.getBluetoothAdapterState({
 *       success: export function (res) {
 *         console.log(res)
 *       }
 *     })
 *     ```
 * 
 */
var onBluetoothAdapterStateChange;
/**
 * 
 *
 * 监听蓝牙适配器状态变化事件
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.onBluetoothAdapterStateChange(function(res) {
 *       console.log(`adapterState changed, now is`, res)
 *     })
 *     ```
 * 
 */
var startBluetoothDevicesDiscovery;
/**
 * 
 *
 * 开始搜寻附近的蓝牙外围设备。注意，该操作比较耗费系统资源，请在搜索并连接到设备后调用 stop 方法停止搜索。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     // 以硬件平台的蓝牙智能灯为例，主服务的 UUID 是 FEE7。传入这个参数，只搜索主服务 UUID 为 FEE7 的设备
 *     swan.startBluetoothDevicesDiscovery({
 *       services: ['FEE7'],
 *       success: export function (res) {
 *         console.log(res)
 *       }
 *     })
 *     ```
 * 
 */
var stopBluetoothDevicesDiscovery;
/**
 * 
 *
 * 停止搜寻附近的蓝牙外围设备。若已经找到需要的蓝牙设备并不需要继续搜索时，建议调用该接口停止蓝牙搜索。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.stopBluetoothDevicesDiscovery({
 *       success: export function (res) {
 *         console.log(res)
 *       }
 *     })
 *     ```
 * 
 */
var getBluetoothDevices;
/**
 * 
 *
 * 获取在小程序蓝牙模块生效期间所有已发现的蓝牙设备，包括已经和本机处于连接状态的设备。
 *
 * **Bug & Tip：**
 *
 * 1.  `tip`: Mac系统可能无法获取`advertisData`及`RSSI`，请使用真机调试
 * 2.  `tip`: 开发者工具和 Android 上获取到的`deviceId`为设备 MAC 地址，iOS 上则为设备 uuid。因此`deviceId`不能硬编码到代码中
 * 3.  `tip`: 注意该接口获取到的设备列表为**小程序蓝牙模块生效期间所有搜索到的蓝牙设备**，若在蓝牙模块使用流程结束后未及时调用 swan.closeBluetoothAdapter 释放资源，会存在调用该接口会返回之前的蓝牙使用流程中搜索到的蓝牙设备，可能设备已经不在用户身边，无法连接。
 * 4.  `tips`: 蓝牙设备在被搜索到时，系统返回的 name 字段一般为广播包中的LocalName字段中的设备名称，而如果与蓝牙设备建立连接，系统返回的 name 字段会改为从蓝牙设备上获取到的GattName。若需要动态改变设备名称并展示，建议使用localName字段。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     // ArrayBuffer转16进度字符串示例
 *     export function ab2hex(buffer) {
 *       var hexArr = Array.protoexport type.map.call(
 *         new Uint8Array(buffer),
 *         function(bit) {
 *           return ('00' + bit.toString(16)).slice(-2)
 *         }
 *       )
 *       return hexArr.join('');
 *     }
 *     swan.getBluetoothDevices({
 *       success: export function (res) {
 *         console.log(res)
 *         if (res.devices[0]) {
 *           console.log(ab2hex(res.devices[0].advertisData))
 *         }
 *       }
 *     })
 *     ```
 * 
 */
var onBluetoothDeviceFound;
/**
 * 
 *
 * 监听寻找到新设备的事件
 *
 * **Bug & Tip：**
 *
 * 1.  `tip`: Mac系统可能无法获取`advertisData`及`RSSI`，请使用真机调试
 * 2.  `tip`: 开发者工具和 Android 上获取到的`deviceId`为设备 MAC 地址，iOS 上则为设备 uuid。因此`deviceId`不能硬编码到代码中
 * 3.  `tip`: 若在onBluetoothDeviceFound回调了某个设备，则此设备会添加到 swan.getBluetoothDevices 接口获取到的数组中
 *
 * **示例代码：**
 *
 *     ```javascript
 *     // ArrayBuffer转16进度字符串示例
 *     export function ab2hex(buffer) {
 *       var hexArr = Array.protoexport type.map.call(
 *         new Uint8Array(buffer),
 *         function(bit) {
 *           return ('00' + bit.toString(16)).slice(-2)
 *         }
 *       )
 *       return hexArr.join('');
 *     }
 *     swan.onBluetoothDeviceFound(function(devices) {
 *       console.log('new device list has founded')
 *       console.dir(devices)
 *       console.log(ab2hex(devices[0].advertisData))
 *     })
 *     ```
 * 
 */
var getConnectedBluetoothDevices;
/**
 * 
 *
 * 根据 uuid 获取处于已连接状态的设备
 *
 * **Bug & Tip：**
 *
 * 1.  `tip`: 开发者工具和 Android 上获取到的`deviceId`为设备 MAC 地址，iOS 上则为设备 uuid。因此`deviceId`不能硬编码到代码中
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.getConnectedBluetoothDevices({
 *       success: export function (res) {
 *         console.log(res)
 *       }
 *     })
 *     ```
 * 
 */
var createBLEConnection;
/**
 * 
 *
 * 连接低功耗蓝牙设备。
 *
 * > 若小程序在之前已有搜索过某个蓝牙设备，并成功建立链接，可直接传入之前搜索获取的deviceId直接尝试连接该设备，无需进行搜索操作。
 *
 * **Bug & Tip：**
 *
 * 1.  `tip`: 安卓手机上如果多次调用create创建连接，有可能导致系统持有同一设备多个连接的实例，导致调用close的时候并不能真正的断开与设备的连接。因此请保证尽量成对的调用create和close接口
 * 2.  `tip`: 蓝牙链接随时可能断开，建议监听 swan.onBLEConnectionStateChange 回调事件，当蓝牙设备断开时按需执行重连操作
 * 3.  `tip`: 若对未连接的设备或已断开连接的设备调用数据读写操作的接口，会返回10006错误，详见错误码，建议进行重连操作
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.createBLEConnection({
 *       // 这里的 deviceId 需要已经通过 createBLEConnection 与对应设备建立链接 
 *       deviceId: deviceId,
 *       success: export function (res) {
 *         console.log(res)
 *       }
 *     })
 *     ```
 * 
 */
var closeBLEConnection;
/**
 * 
 *
 * 断开与低功耗蓝牙设备的连接
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.closeBLEConnection({
 *       deviceId:deviceId
 *       success: export function (res) {
 *         console.log(res)
 *       }
 *     })
 *     ```
 * 
 */
var onBLEConnectionStateChange;
/**
 * 
 *
 * 监听低功耗蓝牙连接状态的改变事件，包括开发者主动连接或断开连接，设备丢失，连接异常断开等等
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.onBLEConnectionStateChange(function(res) {
 *       // 该方法回调中可以用于处理连接意外断开等异常情况
 *       console.log(`device ${res.deviceId} state has changed, connected: ${res.connected}`)
 *     })
 *     ```
 * 
 */
var getBLEDeviceServices;
/**
 * 
 *
 * 获取蓝牙设备所有 service（服务）
 *
 * **Bug & Tip：**
 *
 * 1.  `tip`:iOS平台上后续对特征值的read、write、notify，由于系统需要获取特征值实例，传入的 serviceId 与 characteristicId 必须由 getBLEDeviceServices 与 getBLEDeviceCharacteristics 中获取到后才能使用。建议双平台统一在建立链接后先执行 getBLEDeviceServices 与 getBLEDeviceCharacteristics 后再进行与蓝牙设备的数据交互
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.getBLEDeviceServices({
 *       // 这里的 deviceId 需要已经通过 createBLEConnection 与对应设备建立链接 
 *       deviceId: deviceId,
 *       success: export function (res) {
 *         console.log('device services:', res.services)
 *       }
 *     })
 *     ```
 * 
 */
var getBLEDeviceCharacteristics;
/**
 * 
 *
 * 获取蓝牙设备某个服务中的所有 characteristic（特征值）
 *
 * **Bug & Tip：**
 *
 * 1.  `tip`:传入的serviceId需要在getBLEDeviceServices获取到
 * 2.  `tip`:iOS平台上后续对特征值的read、write、notify，由于系统需要获取特征值实例，传入的 serviceId 与 characteristicId 必须由 getBLEDeviceServices 与 getBLEDeviceCharacteristics 中获取到后才能使用。建议双平台统一在建立链接后先执行 getBLEDeviceServices 与 getBLEDeviceCharacteristics 后再进行与蓝牙设备的数据交互
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.getBLEDeviceCharacteristics({
 *       // 这里的 deviceId 需要已经通过 createBLEConnection 与对应设备建立链接
 *       deviceId: deviceId,
 *       // 这里的 serviceId 需要在上面的 getBLEDeviceServices 接口中获取
 *       serviceId: serviceId,
 *       success: export function (res) {
 *         console.log('device getBLEDeviceCharacteristics:', res.characteristics)
 *       }
 *     })
 *     ```
 * 
 */
var readBLECharacteristicValue;
/**
 * 
 *
 * 读取低功耗蓝牙设备的特征值的二进制数据值。注意：必须设备的特征值支持`read`才可以成功调用，具体参照 characteristic 的 properties 属性
 *
 * **Bug & Tip：**
 *
 * 1.  `tip`: 并行调用多次读写接口存在读写失败的可能性。
 * 2.  `tip`: `read`接口读取到的信息需要在`onBLECharacteristicValueChange`方法注册的回调中获取。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     // 必须在这里的回调才能获取
 *     swan.onBLECharacteristicValueChange(function(characteristic) {
 *       console.log('characteristic value comed:', characteristic)
 *     })
 *
 *     swan.readBLECharacteristicValue({
 *       // 这里的 deviceId 需要已经通过 createBLEConnection 与对应设备建立链接  [**new**]
 *       deviceId: deviceId,
 *       // 这里的 serviceId 需要在上面的 getBLEDeviceServices 接口中获取
 *       serviceId: serviceId,
 *       // 这里的 characteristicId 需要在上面的 getBLEDeviceCharacteristics 接口中获取
 *       characteristicId: characteristicId,
 *       success: export function (res) {
 *         console.log('readBLECharacteristicValue:', res.errCode)
 *       }
 *     })
 *     ```
 * 
 */
var writeBLECharacteristicValue;
/**
 * 
 *
 * 向低功耗蓝牙设备特征值中写入二进制数据。注意：必须设备的特征值支持`write`才可以成功调用，具体参照 characteristic 的 properties 属性
 *
 * _tips: 并行调用多次读写接口存在读写失败的可能性_
 *
 * **Bug & Tip：**
 *
 * 1.  `tip`: 并行调用多次读写接口存在读写失败的可能性。
 * 2.  `tip`: 小程序不会对写入数据包大小做限制，但系统与蓝牙设备会确定蓝牙4.0单次传输的数据大小，超过最大字节数后会发生写入错误，建议每次写入不超过20字节。
 * 3.  `tip`: 安卓平台上，在调用notify成功后立即调用write接口，在部分机型上会发生 10008 系统错误
 * 4.  `bug`: 若单次写入数据过长，iOS平台上存在系统不会有任何回调的情况(包括错误回调)。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     // 向蓝牙设备发送一个0x00的16进制数据
 *     let buffer = new ArrayBuffer(1)
 *     let dataView = new DataView(buffer)
 *     dataView.setUint8(0, 0)
 *
 *     swan.writeBLECharacteristicValue({
 *       // 这里的 deviceId 需要在上面的 getBluetoothDevices 或 onBluetoothDeviceFound 接口中获取
 *       deviceId: deviceId,
 *       // 这里的 serviceId 需要在上面的 getBLEDeviceServices 接口中获取
 *       serviceId: serviceId,
 *       // 这里的 characteristicId 需要在上面的 getBLEDeviceCharacteristics 接口中获取
 *       characteristicId: characteristicId,
 *       // 这里的value是ArrayBuffer类型
 *       value: buffer,
 *       success: export function (res) {
 *         console.log('writeBLECharacteristicValue success', res.errMsg)
 *       }
 *     })
 *     ```
 * 
 */
var notifyBLECharacteristicValueChange;
/**
 * 
 *
 * 启用低功耗蓝牙设备特征值变化时的 notify 功能，订阅特征值。注意：必须设备的特征值支持`notify`或者`indicate`才可以成功调用，具体参照 characteristic 的 properties 属性
 *
 * 另外，必须先启用`notify`才能监听到设备 characteristicValueChange 事件
 *
 * **Bug & Tip：**
 *
 * 1.  `tip`: 订阅操作成功后需要设备主动更新特征值的value，才会触发 swan.onBLECharacteristicValueChange 回调。
 * 2.  `tip`: 安卓平台上，在调用notify成功后立即调用write接口，在部分机型上会发生 10008 系统错误
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.notifyBLECharacteristicValueChange({
 *       state: true, // 启用 notify 功能
 *       // 这里的 deviceId 需要已经通过 createBLEConnection 与对应设备建立链接  
 *       deviceId: deviceId,
 *       // 这里的 serviceId 需要在上面的 getBLEDeviceServices 接口中获取
 *       serviceId: serviceId,
 *       // 这里的 characteristicId 需要在上面的 getBLEDeviceCharacteristics 接口中获取
 *       characteristicId: characteristicId,
 *       success: export function (res) {
 *         console.log('notifyBLECharacteristicValueChange success', res.errMsg)
 *       }
 *     })
 *     ```
 * 
 */
var onBLECharacteristicValueChange;
/**
 * 
 *
 * 监听低功耗蓝牙设备的特征值变化。必须先启用`notify`接口才能接收到设备推送的notification。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     // ArrayBuffer转16进度字符串示例
 *     export function ab2hex(buffer) {
 *       var hexArr = Array.protoexport type.map.call(
 *         new Uint8Array(buffer),
 *         function(bit) {
 *           return ('00' + bit.toString(16)).slice(-2)
 *         }
 *       )
 *       return hexArr.join('');
 *     }
 *     swan.onBLECharacteristicValueChange(function(res) {
 *       console.log(`characteristic ${res.characteristicId} has changed, now is ${res.value}`)
 *       console.log(ab2hext(res.value))
 *     })
 *     ```
 * 
 */
var startBeaconDiscovery;
/**
 * 
 *
 * 开始搜索附近的`iBeacon`设备
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.startBeaconDiscovery({
 *         success(res) {
 *         }
 *     })
 *     ```
 * 
 */
var stopBeaconDiscovery;
/**
 * 
 *
 * 停止搜索附近的`iBeacon`设备
 * 
 */
var getBeacons;
/**
 * 
 *
 * 获取所有已搜索到的`iBeacon`设备
 * 
 */
var onBeaconUpdate;
/**
 * 
 *
 * 监听 `iBeacon` 设备的更新事件
 * 
 */
var onBeaconServiceChange;
/**
 * 
 *
 * 监听 `iBeacon` 服务的状态变化
 * 
 */
var setKeepScreenOn;
/**
 * 
 *
 * 设置是否保持常亮状态。仅在当前小程序生效，离开小程序后设置失效。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     // 保持屏幕常亮
 *     swan.setKeepScreenOn({
 *         keepScreenOn: true
 *     })
 *     ```
 * 
 */
/**
 * 
 *
 * 监听用户主动截屏事件，用户使用系统截屏按键截屏时触发此事件
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.onUserCaptureScreen(function(res) {
 *         console.log('用户截屏了')
 *     })
 *     ```
 * 
 */
var addPhoneContact;
/**
 * 
 *
 * 调用后，用户可以选择将该表单以“新增联系人”或“添加到已有联系人”的方式，写入手机系统通讯录，完成手机通讯录联系人和联系方式的增加。
 *
 * **回调结果：**
 *
 *   回调类型  |  errMsg           |  说明                 
 * ------------|-------------------|-----------------------
 *   success   |  ok               |  添加成功             
 *   fail      |  fail cancel      |  用户取消操作         
 *   fail      |  fail ${detail}   |调用失败，detail 加上详细信息
 * 
 */
var getHCEState;
/**
 * 
 *
 * 判断当前设备是否支持 HCE 能力。
 *
 * **success返回参数说明：**
 *
 *     ```javascript
 *     swan.getHCEState({
 *       success: function(res) {
 *         console.log(res.errCode)
 *       }
 *     })
 *     ```
 * 
 */
var startHCE;
/**
 * 
 *
 * 初始化 NFC 模块。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.startHCE({
 *       aid_list: ['F222222222']
 *       success: function(res) {
 *         console.log(res.errMsg)
 *       }
 *     })
 *     ```
 * 
 */
var stopHCE;
/**
 * 
 *
 * 关闭 NFC 模块。仅在安卓系统下有效。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.stopHCE({
 *       success: function(res) {
 *         console.log(res.errMsg)
 *       }
 *     })
 *     ```
 * 
 */
var onHCEMessage;
/**
 * 
 *
 * 监听 NFC 设备的消息回调，并在回调中处理。返回参数中 `messageType` 表示消息类型，目前有如下值：
 *
 * *   1：消息为HCE Apdu Command类型，小程序需对此指令进行处理，并调用 `sendHCEMessage` 接口返回处理指令；
 * *   2：消息为设备离场事件
 * 
 */
var sendHCEMessage;
/**
 * 
 *
 * 发送 NFC 消息。仅在安卓系统下有效。
 *
 * **success返回参数说明：**
 *
 *     ```javascript
 *     const buffer = new ArrayBuffer(1)
 *     const dataView = new DataView(buffer)
 *     dataView.setUint8(0, 0)
 *
 *     swan.startHCE({
 *       success: function(res) {
 *         swan.onHCEMessage(function(res) {
 *           if (res.messageType === 1) {
 *             swan.sendHCEMessage({data: buffer})
 *           }
 *         })
 *       }
 *     })
 *     ```
 * 
 */
var startWifi;
/**
 * 
 *
 * 初始化 Wi-Fi 模块。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.startWifi({
 *       success: function(res) {
 *         console.log(res.errMsg)
 *       }
 *     })
 *     ```
 * 
 */
var stopWifi;
/**
 * 
 *
 * 关闭 Wi-Fi 模块。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.stopWifi({
 *       success: function(res) {
 *         console.log(res.errMsg)
 *       }
 *     })
 *     ```
 * 
 */
var connectWifi;
/**
 * 
 *
 * 连接 Wi-Fi。若已知 Wi-Fi 信息，可以直接利用该接口连接。仅 Android 与 iOS 11 以上版本支持。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.connectWifi({
 *       SSID: '',
 *       BSSID: '',
 *       success: function(res) {
 *         console.log(res.errMsg)
 *       }
 *     })
 *     ```
 * 
 */
var getWifiList;
/**
 * 
 *
 * 请求获取 Wi-Fi 列表，在 `onGetWifiList` 注册的回调中返回 wifiList 数据。iOS 将跳转到系统的 Wi-Fi 界面，Android 不会跳转。 **iOS 11.0 及 iOS 11.1 两个版本因系统问题，该方法失效。但在 iOS 11.2 中已修复。**
 * 
 */
var onGetWifiList;
/**
 * 
 *
 * 监听在获取到 Wi-Fi 列表数据时的事件，在回调中将返回 wifiList。
 * 
 */
var setWifiList;
/**
 * 
 *
 * **iOS特有接口** 在 `onGetWifiList` 回调后，利用接口设置 wifiList 中 AP 的相关信息。
 *
 * 注意：
 *
 * 1.  该接口只能在 `onGetWifiList` 回调之后才能调用。
 * 2.  此时客户端会挂起，等待小程序设置 Wi-Fi 信息，请务必尽快调用该接口，若无数据请传入一个空数组。
 * 3.  有可能随着周边 Wi-Fi 列表的刷新，单个流程内收到多次带有存在重复的 Wi-Fi 列表的回调。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.onGetWifiList(function(res) {
 *       if (res.wifiList.length) {
 *         swan.setWifiList({
 *           wifiList: [{
 *             SSID: res.wifiList[0].SSID,
 *             BSSID: res.wifiList[0].BSSID,
 *             password: '123456'
 *           }]
 *         })
 *       } else {
 *         swan.setWifiList({
 *           wifiList: []
 *         })
 *       }
 *     })
 *     swan.getWifiList()
 *     ```
 * 
 */
var onWifiConnected;
/**
 * 
 *
 * 监听连接上 Wi-Fi 的事件。
 * 
 */
var getConnectedWifi;
/**
 * 
 *
 * 获取已连接中的 Wi-Fi 信息
 *
 * **errCode列表：**
 *
 * 每个接口调用的时候，都会返回 `errCode` 字段。
 *
 *   错误码  |  说明                    |  备注                        
 * ----------|--------------------------|------------------------------
 *   0       |  ok                      |  正常                        
 *   12000   |  not init                |  未先调用startWifi接口       
 *   12001   |  system not support      |  当前系统不支持相关能力      
 *   12002   |  password error          |  Wi-Fi 密码错误              
 *   12003   |  connection timeout      |  连接超时                    
 *   12004   |  duplicate request       |  重复连接 Wi-Fi              
 *   12005   |  wifi not turned on      |Android特有，未打开 Wi-Fi 开关
 *   12006   |  gps not turned on       |Android特有，未打开 GPS 定位开关
 *   12007   |  user denied             |  用户拒绝授权链接 Wi-Fi      
 *   12008   |  invalid SSID            |  无效SSID                    
 *   12009   |  system config err       | 系统运营商配置拒绝连接 Wi-Fi 
 *   12010   |  system internal error   |系统其他错误，需要在errmsg打印具体的错误原因
 *   12011   |  weapp in background     |  应用在后台无法配置 Wi-Fi    
 * 
 */
var showToast;
/**
 * 显示消息提示框
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.showToast({
 *       title: '成功',
 *       icon: 'success',
 *       duration: 2000
 *     })
 *     ```
 * 
 */
var showLoading;
/**
 * 
 *
 * 显示 loading 提示框, 需主动调用 swan.hideLoading才能关闭提示框
 * 
 */
var hideToast;
/**
 * 隐藏消息提示框
 */
var hideLoading;
/**
 * 隐藏 loading 提示框
 *
 * **示例：**
 *
 * ```javascript
 * swan.showLoading({
 *   title: '加载中',
 * })
 *
 * setTimeout(function(){
 *   swan.hideLoading()
 * }, 2000)
 * ```
 */
var showModal;
/**
 * 显示模态框
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.showModal({
 *       title: '提示',
 *       content: '这是一个模态弹窗',
 *       success: function(res) {
 *         if (res.confirm) {
 *           console.log('用户点击确定')
 *         } else if (res.cancel) {
 *           console.log('用户点击取消')
 *         }
 *       }
 *     })
 *     ```
 * 
 */
var showActionSheet;
/**
 * 显示操作菜单
 *
 * **Bug & Tip：**
 *
 * 1.  `bug`: `Android` `6.3.30`，swan.showModal 的返回的 confirm 一直为 true；
 * 2.  `tip`: swan.showActionSheet 点击取消或蒙层时，回调 `fail`, errMsg 为 "showActionSheet:fail cancel"；
 * 3.  `tip`: swan.showLoading 和 swan.showToast 同时只能显示一个，但 swan.hideToast/swan.hideLoading 也应当配对使用；
 * 4.  `tip`: `iOS` swan.showModal 点击蒙层不会关闭模态弹窗，所以尽量避免使用“取消”分支中实现业务逻辑。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.showActionSheet({
 *       itemList: ['A', 'B', 'C'],
 *       success: function(res) {
 *         console.log(res.tapIndex)
 *       },
 *       fail: function(res) {
 *         console.log(res.errMsg)
 *       }
 *     })
 *     ```
 * 
 */
var setTopBarText;
/**
 * 
 *
 * 动态设置置顶栏文字内容，只有当前小程序被置顶时能生效，如果当前小程序没有被置顶，也能调用成功，但是不会立即生效，只有在用户将这个小程序置顶后才换上设置的文字内容。**注意：调用成功后，需间隔 5s 才能再次调用此接口，如果在 5s 内再次调用此接口，会回调 fail，errMsg："setTopBarText: fail invoke too frequently"**
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.setTopBarText({
 *       text: 'hello, world!'
 *     })
 *     ```
 * 
 */
var setNavigationBarTitle;
/**
 * 动态设置当前页面的标题。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.setNavigationBarTitle({
 *       title: '当前页面'
 *     })
 *     ```
 * 
 */
/**
 * 在当前页面显示导航条加载动画。
 * 
 */
/**
 * 隐藏导航条加载动画。
 * 
 */
var setNavigationBarColor;
/**
 * 
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.setNavigationBarColor({
 *         frontColor: '#ffffff',
 *         backgroundColor: '#ff0000',
 *         animation: {
 *             duration: 400,
 *             timingFunc: 'easeIn'
 *         }
 *     })
 *     ```
 * 
 */
var setTabBarBadge;
/**
 * 
 *
 * 为 tabBar 某一项的右上角添加文本
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.setTabBarBadge({
 *       index: 0,
 *       text: '1'
 *     })
 *     ```
 * 
 */
var removeTabBarBadge;
/**
 * 
 *
 * 移除 tabBar 某一项右上角的文本
 * 
 */
var showTabBarRedDot;
/**
 * 
 *
 * 显示 tabBar 某一项的右上角的红点
 * 
 */
var hideTabBarRedDot;
/**
 * 
 *
 * 隐藏 tabBar 某一项的右上角的红点
 * 
 */
var setTabBarStyle;
/**
 * 
 *
 * 动态设置 tabBar 的整体样式
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.setTabBarStyle({
 *         color: '#FF0000',
 *         selectedColor: '#00FF00',
 *         backgroundColor: '#0000FF',
 *         borderStyle: 'white'
 *     })
 *     ```
 * 
 */
var setTabBarItem;
/**
 * 
 *
 * 动态设置 tabBar 某一项的内容
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.setTabBarItem({
 *         index: 0,
 *         text: 'text',
 *         iconPath: '/path/to/iconPath',
 *         selectedIconPath: '/path/to/selectedIconPath'
 *     })
 *     ```
 * 
 */
var showTabBar;
/**
 * 
 *
 * 显示 tabBar
 * 
 */
var hideTabBar;
/**
 * 
 *
 * 隐藏 tabBar
 * 
 */
var setBackgroundColor;
/**
 * 
 *
 * 动态设置窗口的背景色
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.setBackgroundColor({
 *         backgroundColor: '#ffffff', // 窗口的背景色为白色
 *     })
 *
 *     swan.setBackgroundColor({
 *         backgroundColorTop: '#ffffff', // 顶部窗口的背景色为白色
 *         backgroundColorBottom: '#ffffff', // 底部窗口的背景色为白色
 *     })
 *     ```
 * 
 */
var setBackgroundTextStyle;
/**
 * 
 *
 * 动态设置下拉背景字体、loading 图的样式
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.setBackgroundTextStyle({
 *         textStyle: 'dark', // 下拉背景字体、loading 图的样式为dark
 *     })
 *     ```
 * 
 */
var navigateTo;
/**
 * 保留当前页面，跳转到应用内的某个页面，使用`swan.navigateBack`可以返回到原页面。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.navigateTo({
 *       url: 'test?id=1'
 *     })
 *     ```
 *
 * **示例代码：**
 *
 *     ```javascript
 *     //test.js
 *     Page({
 *       onLoad: function(option){
 *         console.log(option.query)
 *       }
 *     })
 *     ```
 * 
 */
var redirectTo;
/**
 * 关闭当前页面，跳转到应用内的某个页面。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.redirectTo({
 *       url: 'test?id=1'
 *     })
 *     ```
 * 
 */
var reLaunch;
/**
 * 
 *
 * 关闭所有页面，打开到应用内的某个页面。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.reLaunch({
 *       url: 'test?id=1'
 *     })
 *     ```
 *
 * **示例代码：**
 *
 *     ```javascript
 *     //test.js
 *     Page({
 *       onLoad: function(option){
 *         console.log(option.query)
 *       }
 *     })
 *     ```
 * 
 */
var switchTab;
/**
 * 跳转到 tabBar 页面，并关闭其他所有非 tabBar 页面
 *
 * **示例代码：**
 *
 *     ```json
 *     {
 *       "tabBar": {
 *         "list": [{
 *           "pagePath": "index",
 *           "text": "首页"
 *         },{
 *           "pagePath": "other",
 *           "text": "其他"
 *         }]
 *       }
 *     }
 *     ```
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.switchTab({
 *       url: '/index'
 *     })
 *     ```
 * 
 */
var navigateBack;
/**
 * 关闭当前页面，返回上一页面或多级页面。可通过 `getCurrentPages()`获取当前的页面栈，决定需要返回几层。
 *
 * **Tip：**
 *
 * 1.  `tip`: swan.navigateTo 和 swan.redirectTo 不允许跳转到 tabbar 页面，只能用 swan.switchTab 跳转到 tabbar 页面
 *
 * **示例代码：**
 *
 *     ```javascript
 *     // 注意：调用 navigateTo 跳转时，调用该方法的页面会被加入堆栈，而 redirectTo 方法则不会。见下方示例代码
 *
 *     // 此处是A页面
 *     swan.navigateTo({
 *       url: 'B?id=1'
 *     })
 *
 *     // 此处是B页面
 *     swan.navigateTo({
 *       url: 'C?id=1'
 *     })
 *
 *     // 在C页面内 navigateBack，将返回A页面
 *     swan.navigateBack({
 *       delta: 2
 *     })
 *     ```
 * 
 */
var createAnimation;
/**
 * 创建一个动画实例animation。调用实例的方法来描述动画。最后通过动画实例的`export`方法导出动画数据传递给组件的`animation`属性。
 *
 * **注意: `export` 方法每次调用后会清掉之前的动画操作**
 *
 * **timingFunction 有效值：**
 *
 *     ```javascript
 *     var animation = swan.createAnimation({
 *       transformOrigin: "50% 50%",
 *       duration: 1000,
 *       timingFunction: "ease",
 *       delay: 0
 *     })
 *     ```
 * 
 */
var Animation = exports.Animation = /*#__PURE__*/(0, _createClass2.default)(function Animation() {
  (0, _classCallCheck2.default)(this, Animation);
});
var pageScrollTo;
/**
 * 
 *
 * 将页面滚动到目标位置。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.pageScrollTo({
 *       scrollTop: 0,
 *       duration: 300
 *     })
 *     ```
 * 
 */
/**
 *
 * **定义：**
 *
 * 创建 canvas 绘图上下文（指定 canvasId）。在自定义组件下，第二个参数传入组件实例this，以操作组件内 `<canvas/>` 组件
 *
 * **Tip**: 需要指定 canvasId，该绘图上下文只作用于对应的 `<canvas/>`
 * 
 */
var canvasToTempFilePath;
/**
 * 把当前画布指定区域的内容导出生成指定大小的图片，并返回文件路径。在自定义组件下，第二个参数传入组件实例this，以操作组件内 `<canvas/>` 组件
 *
 * **Bug & Tip：**
 *
 * 1.  `tip`: 在 `draw` 回调里调用该方法才能保证图片导出成功。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.canvasToTempFilePath({
 *       x: 100,
 *       y: 200,
 *       width: 50,
 *       height: 50,
 *       destWidth: 100,
 *       destHeight: 100,
 *       canvasId: 'myCanvas',
 *       success: function(res) {
 *         console.log(res.tempFilePath)
 *       } 
 *     })
 *     ```
 * 
 */
var canvasGetImageData;
/**
 * 
 *
 * 返回一个数组，用来描述 canvas 区域隐含的像素数据。在自定义组件下，第二个参数传入组件实例this，以操作组件内 `<canvas/>` 组件
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.canvasGetImageData({
 *       canvasId: 'myCanvas',
 *       x: 0,
 *       y: 0,
 *       width: 100,
 *       height: 100,
 *       success(res) {
 *         console.log(res.width) // 100
 *         console.log(res.height) // 100
 *         console.log(res.data instanceof Uint8ClampedArray) // true
 *         console.log(res.data.length) // 100 * 100 * 4
 *       }
 *     })
 *     ```
 * 
 */
var canvasPutImageData;
/**
 * 
 *
 * 将像素数据绘制到画布的方法。在自定义组件下，第二个参数传入组件实例this，以操作组件内 `<canvas/>` 组件
 *
 * **示例代码：**
 *
 *     ```javascript
 *     const data = new Uint8ClampedArray([255, 0, 0, 1])
 *     swan.canvasPutImageData({
 *       canvasId: 'myCanvas',
 *       x: 0,
 *       y: 0,
 *       width: 1,
 *       data: data,
 *       success(res) {}
 *     })
 *     ```
 * 
 */
var startPullDownRefresh;
/**
 * 
 *
 * 开始下拉刷新，调用后触发下拉刷新动画，效果与用户手动下拉刷新一致
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.startPullDownRefresh()
 *     ```
 * 
 */
/**
 * 停止当前页面下拉刷新。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     Page({
 *       onPullDownRefresh: function(){
 *         swan.stopPullDownRefresh()
 *       }
 *     })
 *     ```
 * 
 */
/**
 * 
 *
 * 返回一个SelectorQuery对象实例。可以在这个实例上使用`select`等方法选择节点，并使用`boundingClientRect`等方法选择需要查询的信息。
 *
 * **selectorQuery.in(component)：**
 *
 * 
 *
 * 将选择器的选取范围更改为自定义组件`component`内。（初始时，选择器仅选取页面范围的节点，不会选取任何自定义组件中的节点。）
 *
 * **selectorQuery.select(selector)：**
 *
 * 在当前页面下选择第一个匹配选择器`selector`的节点，返回一个`NodesRef`对象实例，可以用于获取节点信息。
 *
 * `selector`类似于CSS的选择器，但仅支持下列语法。
 *
 * *   ID选择器：`#the-id`
 * *   class选择器（可以连续指定多个）：`.a-class.another-class`
 * *   子元素选择器：`.the-parent > .the-child`
 * *   后代选择器：`.the-ancestor .the-descendant`
 * *   跨自定义组件的后代选择器：`.the-ancestor >>> .the-descendant`
 * *   多选择器的并集：`#a-node, .some-other-nodes`
 *
 * **selectorQuery.selectAll(selector)：**
 *
 * 在当前页面下选择匹配选择器`selector`的节点，返回一个`NodesRef`对象实例。 与`selectorQuery.selectNode(selector)`不同的是，它选择所有匹配选择器的节点。
 *
 * **selectorQuery.selectViewport()：**
 *
 * 选择显示区域，可用于获取显示区域的尺寸、滚动位置等信息，返回一个`NodesRef`对象实例。
 *
 * **nodesRef.boundingClientRect([callback])：**
 *
 * 添加节点的布局位置的查询请求，相对于显示区域，以像素为单位。其功能类似于DOM的getBoundingClientRect。返回值是nodesRef对应的selectorQuery。
 *
 * 返回的节点信息中，每个节点的位置用`left`、`right`、`top`、`bottom`、`width`、`height`字段描述。如果提供了callback回调函数，在执行selectQuery的exec方法后，节点信息会在callback中返回。
 *
 * **nodesRef.scrollOffset([callback])：**
 *
 * 添加节点的滚动位置查询请求，以像素为单位。节点必须是`scroll-view`或者viewport。返回值是nodesRef对应的selectorQuery。
 *
 * 返回的节点信息中，每个节点的滚动位置用`scrollLeft`、`scrollTop`字段描述。如果提供了callback回调函数，在执行selectQuery的exec方法后，节点信息会在callback中返回。
 *
 * **nodesRef.fields(fields, [callback])：**
 *
 * 获取节点的相关信息，需要获取的字段在`fields`中指定。返回值是nodesRef对应的selectorQuery。可指定获取的字段包括：
 *
 * > 注意： computedStyle 的优先级高于 size，当同时在 computedStyle 里指定了 width/height 和传入了 size: true，则优先返回 computedStyle 获取到的 width/height。
 *
 * **selectorQuery.exec([callback])：**
 *
 * 执行所有的请求，请求结果按请求次序构成数组，在callback的第一个参数中返回。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     Page({
 *       queryMultipleNodes: function(){
 *         var query = swan.createSelectorQuery()
 *         query.select('#the-id').boundingClientRect()
 *         query.selectViewport().scrollOffset()
 *         query.exec(function(res){
 *           res[0].top       // #the-id节点的上边界坐标
 *           res[1].scrollTop // 显示区域的竖直滚动位置
 *         })
 *       }
 *     })
 *     ```
 *
 * **示例代码：**
 *
 *     ```javascript
 *     Component({
 *       queryMultipleNodes: function(){
 *         var query = swan.createSelectorQuery().in(this)
 *         query.select('#the-id').boundingClientRect(function(res){
 *           res.top // 这个组件内 #the-id 节点的上边界坐标
 *         }).exec()
 *       }
 *     })
 *     ```
 *
 * **示例代码：**
 *
 *     ```javascript
 *     Page({
 *       getRect: function(){
 *         swan.createSelectorQuery().select('#the-id').boundingClientRect(function(rect){
 *           rect.id      // 节点的ID
 *           rect.dataset // 节点的dataset
 *           rect.left    // 节点的左边界坐标
 *           rect.right   // 节点的右边界坐标
 *           rect.top     // 节点的上边界坐标
 *           rect.bottom  // 节点的下边界坐标
 *           rect.width   // 节点的宽度
 *           rect.height  // 节点的高度
 *         }).exec()
 *       },
 *       getAllRects: function(){
 *         swan.createSelectorQuery().selectAll('.a-class').boundingClientRect(function(rects){
 *           rects.forEach(function(rect){
 *             rect.id      // 节点的ID
 *             rect.dataset // 节点的dataset
 *             rect.left    // 节点的左边界坐标
 *             rect.right   // 节点的右边界坐标
 *             rect.top     // 节点的上边界坐标
 *             rect.bottom  // 节点的下边界坐标
 *             rect.width   // 节点的宽度
 *             rect.height  // 节点的高度
 *           })
 *         }).exec()
 *       }
 *     })
 *     ```
 *
 * **示例代码：**
 *
 *     ```javascript
 *     Page({
 *       getScrollOffset: function(){
 *         swan.createSelectorQuery().selectViewport().scrollOffset(function(res){
 *           res.id      // 节点的ID
 *           res.dataset // 节点的dataset
 *           res.scrollLeft // 节点的水平滚动位置
 *           res.scrollTop  // 节点的竖直滚动位置
 *         }).exec()
 *       }
 *     })
 *     ```
 *
 * **示例代码：**
 *
 *     ```javascript
 *     Page({
 *       getFields: function(){
 *         swan.createSelectorQuery().select('#the-id').fields({
 *           dataset: true,
 *           size: true,
 *           scrollOffset: true,
 *           properties: ['scrollX', 'scrollY'],
 *           computedStyle: ['margin', 'backgroundColor']
 *         }, function(res){
 *           res.dataset    // 节点的dataset
 *           res.width      // 节点的宽度
 *           res.height     // 节点的高度
 *           res.scrollLeft // 节点的水平滚动位置
 *           res.scrollTop  // 节点的竖直滚动位置
 *           res.scrollX    // 节点 scroll-x 属性的当前值
 *           res.scrollY    // 节点 scroll-y 属性的当前值
 *           // 此处返回指定要返回的样式名
 *           res.margin
 *           res.backgroundColor
 *         }).exec()
 *       }
 *     })
 *     ```
 */
var SelectorQuery = exports.SelectorQuery = /*#__PURE__*/(0, _createClass2.default)(function SelectorQuery() {
  (0, _classCallCheck2.default)(this, SelectorQuery);
});
var getExtConfig;
/**
 * 
 *
 * 获取第三方平台自定义的数据字段。
 *
 * **Bug & Tip：**
 *
 * 1.  `swan.getExtConfig` 暂时无法通过 `swan.canIUse` 判断是否兼容，开发者需要自行判断 `swan.getExtConfig` 是否存在来兼容
 *
 * **示例代码：**
 *
 *     ```javascript
 *     if(swan.getExtConfig) {
 *       swan.getExtConfig({
 *         success: export function (res) {
 *           console.log(res.extConfig)
 *         }
 *       })
 *     }
 *     ```
 * 
 */
var getExtConfigSync;
/**
 * 
 *
 * 获取第三方平台自定义的数据字段的同步接口。
 *
 * **Bug & Tip：**
 *
 * 1.  `swan.getExtConfigSync` 暂时无法通过 `swan.canIUse` 判断是否兼容，开发者需要自行判断 `swan.getExtConfigSync` 是否存在来兼容
 *
 * **示例代码：**
 *
 *     ```javascript
 *     let extConfig = swan.getExtConfigSync? swan.getExtConfigSync(): {}
 *     console.log(extConfig)
 *     ```
 * 
 */
var login;
/**
 * 调用接口swan.login() 获取**临时登录凭证（code）**
 *
 * **示例代码：**
 *
 *     ```javascript
 *     //app.js
 *     App({
 *       onLaunch: function() {
 *         swan.login({
 *           success: function(res) {
 *             if (res.code) {
 *               //发起网络请求
 *               swan.request({
 *                 url: 'https://test.com/onLogin',
 *                 data: {
 *                   code: res.code
 *                 }
 *               })
 *             } else {
 *               console.log('登录失败！' + res.errMsg)
 *             }
 *           }
 *         });
 *       }
 *     })
 *     ```
 * 
 */
var checkSession;
/**
 * 校验用户当前session_key是否有效。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.checkSession({
 *       success: function(){
 *         //session_key 未过期，并且在本生命周期一直有效
 *       },
 *       fail: function(){
 *         // session_key 已经失效，需要重新执行登录流程
 *         swan.login() //重新登录
 *         ....
 *       }
 *     })
 *     ```
 * 
 */
var authorize;
/**
 * 
 *
 * 提前向用户发起授权请求。调用后会立刻弹窗询问用户是否同意授权小程序使用某项功能或获取用户的某些数据，但不会实际调用对应接口。如果用户之前已经同意授权，则不会出现弹窗，直接返回成功。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     // 可以通过 swan.getSetting 先查询一下用户是否授权了 "scope.record" 这个 scope
 *     swan.getSetting({
 *         success(res) {
 *             if (!res.authSetting['scope.record']) {
 *                 swan.authorize({
 *                     scope: 'scope.record',
 *                     success() {
 *                         // 用户已经同意小程序使用录音功能，后续调用 swan.startRecord 接口不会弹窗询问
 *                         swan.startRecord()
 *                     }
 *                 })
 *             }
 *         }
 *     })
 *     ```
 * 
 */
var getUserInfo;
/**
 * **注意：此接口有调整，使用该接口将不再出现授权弹窗，请使用 <button open-export type="getUserInfo"></button>引导用户主动进行授权操作**
 *
 * 1.  当用户未授权过，调用该接口将直接报错
 * 2.  当用户授权过，可以使用该接口获取用户信息
 *
 * **示例代码：**
 *
 *     ```html
 *     <!--swan-->
 *     <!-- 如果只是展示用户头像昵称，可以使用 <open-data /> 组件 -->
 *     <open-data export type="userAvatarUrl"></open-data>
 *     <open-data export type="userNickName"></open-data>
 *     <!-- 需要使用 button 来授权登录 -->
 *     <button s-if="{{canIUse}}" open-export type="getUserInfo" bindgetuserinfo="bindGetUserInfo">授权登录</button>
 *     <view s-else>请升级手百版本</view>
 *     ```
 *
 * **示例代码：**
 *
 *     ```javascript
 *     //js
 *     Page({
 *       data: {
 *         canIUse: swan.canIUse('button.open-export type.getUserInfo')
 *       },
 *       onLoad: function() {
 *         // 查看是否授权
 *         swan.getSetting({
 *           success: function(res){
 *             if (res.authSetting['scope.userInfo']) {
 *               // 已经授权，可以直接调用 getUserInfo 获取头像昵称
 *               swan.getUserInfo({
 *                 success: function(res) {
 *                   console(res.userInfo)
 *                 }
 *               })
 *             }
 *           }
 *         })
 *       },
 *       bindGetUserInfo: function(e) {
 *         console.log(e.detail.userInfo)
 *       }
 *     })
 *     ```
 *
 * **示例代码：**
 *
 *     ```json
 *     {
 *         "openId": "OPENID",
 *         "nickName": "NICKNAME",
 *         "gender": GENDER,
 *         "city": "CITY",
 *         "province": "PROVINCE",
 *         "country": "COUNTRY",
 *         "avatarUrl": "AVATARURL",
 *         "unionId": "UNIONID",
 *         "watermark":
 *         {
 *             "appid":"APPID",
 *         "timestamp":TIMESTAMP
 *         }
 *     }
 *     ```
 * 
 */
var requestPayment;
/**
 * 发起支付。
 *
 * **回调结果：**
 *
 *   回调类型  |  errMsg                                 |  说明                                    
 * ------------|-----------------------------------------|------------------------------------------
 *   success   |  requestPayment:ok                      |  调用支付成功                            
 *   fail      |  requestPayment:fail cancel             |  用户取消支付                            
 *   fail      |  requestPayment:fail (detail message)   |调用支付失败，其中 detail message 为后台返回的详细失败原因
 *
 * **Bug & Tip：**
 *
 * 1.  `bug`: 6.5.2 及之前版本中，用户取消支付不会触发 fail 回调，只会触发 complete 回调，回调 errMsg 为 'requestPayment:cancel'
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.requestPayment({
 *        'timeStamp': '',
 *        'nonceStr': '',
 *        'package': '',
 *        'signType': 'MD5',
 *        'paySign': '',
 *        'success':function(res){
 *        },
 *        'fail':function(res){
 *        }
 *     })
 *     ```
 * 
 */
var showShareMenu;
/**
 * 
 *
 * 显示当前页面的转发按钮
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.showShareMenu({
 *       withShareTicket: true
 *     })
 *     ```
 * 
 */
var hideShareMenu;
/**
 * 
 *
 * 隐藏转发按钮
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.hideShareMenu()
 *     ```
 * 
 */
var updateShareMenu;
/**
 * 
 *
 * 更新转发属性
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.updateShareMenu({
 *       withShareTicket: true,
 *       success() {
 *       }
 *     })
 *     ```
 * 
 */
var getShareInfo;
/**
 * 
 *
 * 获取转发详细信息
 * 
 */
var chooseAddress;
/**
 * 
 *
 * 调起用户编辑收货地址原生界面，并在编辑完成后返回用户选择的地址。
 *
 * 需要用户授权scope.address
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.chooseAddress({
 *       success: export function (res) {
 *         console.log(res.userName)
 *         console.log(res.postalCode)
 *         console.log(res.provinceName)
 *         console.log(res.cityName)
 *         console.log(res.countyName)
 *         console.log(res.detailInfo)
 *         console.log(res.nationalCode)
 *         console.log(res.telNumber)
 *       }
 *     })
 *     ```
 * 
 */
var addCard;
/**
 * 
 *
 * 批量添加卡券。
 *
 * **回调结果：**
 *
 *   回调类型  |  errMsg                          |  说明                                    
 * ------------|----------------------------------|------------------------------------------
 *   success   |  addCard:ok                      |  添加卡券成功                            
 *   fail      |  addCard:fail cancel             |  用户取消添加卡券                        
 *   fail      |  addCard:fail (detail message)   |添加卡券失败，其中 detail message 为后台返回的详细失败原因
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.addCard({
 *       cardList: [
 *         {
 *           cardId: '',
 *           cardExt: '{"code": "", "openid": "", "timestamp": "", "signature":""}'
 *         }, {
 *           cardId: '',
 *           cardExt: '{"code": "", "openid": "", "timestamp": "", "signature":""}'
 *         }
 *       ],
 *       success: function(res) {
 *         console.log(res.cardList) // 卡券添加结果
 *       }
 *     })
 *     ```
 * 
 */
var openCard;
/**
 * 
 *
 * 查看卡包中的卡券。
 *
 * **Tip：**
 *
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.openCard({
 *       cardList: [
 *         {
 *           cardId: '',
 *           code: ''
 *         }, {
 *           cardId: '',
 *           code: ''
 *         }
 *       ],
 *       success: function(res) {
 *       }
 *     })
 *     ```
 * 
 */
var openSetting;
/**
 * 
 * > 
 * > 此接口即将废弃，请使用<button>组件来使用此功能
 *
 * 调起客户端小程序设置界面，返回用户设置的操作结果。
 *
 * 注：设置界面只会出现小程序已经向用户请求过的权限。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.openSetting({
 *       success: (res) => {
 *
 *          // res.authSetting = {
 *          //   "scope.userInfo": true,
 *          //   "scope.userLocation": true
 *          // }
 *
 *       }
 *     })
 *     ```
 * 
 */
var getSetting;
/**
 * 
 *
 * 获取用户的当前设置。
 *
 * 注：返回值中只会出现小程序已经向用户请求过的权限。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.getSetting({
 *       success: (res) => {
 *
 *          // res.authSetting = {
 *          //   "scope.userInfo": true,
 *          //   "scope.userLocation": true
 *          // }
 *
 *       }
 *     })
 *     ```
 * 
 */
var getWeRunData;
/**
 * 
 *
 * 获取用户过去三十天运动步数，需要先调用 swan.login接口。
 *
 * 需要用户授权scope.werun
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.getWeRunData({
 *         success(res) {
 *             const encryptedData = res.encryptedData
 *         }
 *     })
 *     ```
 * 
 */
var navigateToMiniProgram;
/**
 * 
 * > 
 * > 此接口即将废弃，请使用 <navigator>组件来使用此功能
 *
 * 打开同一公众号下关联的另一个小程序。**（注：必须是同一公众号下，而非同个 open 账号下）**
 *
 * **Bug & Tip：**
 *
 * 1.  `tip`: 在开发者工具上调用此 API 并不会真实的跳转到另外的小程序，但是开发者工具会校验本次调用跳转是否成功
 * 2.  `tip`: 开发者工具上支持被跳转的小程序处理接收参数的调试
 * 3.  `tip`: 只有同一公众号下的关联的小程序之间才可相互跳转 
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.navigateToMiniProgram({
 *       appId: '',
 *       path: 'pages/index/index?id=123',
 *       extraData: {
 *         foo: 'bar'
 *       },
 *       envVersion: 'develop',
 *       success(res) {
 *         // 打开成功
 *       }
 *     })
 *     ```
 * 
 */
var navigateBackMiniProgram;
/**
 * 
 * > 
 * > iOS 客户端 6.5.9 版本开始支持，Android 客户端即将在 6.5.10 版本开始支持，请先使用 iOS 客户端进行调试
 *
 * 返回到上一个小程序，只有在当前小程序是被其他小程序打开时可以调用成功
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.navigateBackMiniProgram({
 *       extraData: {
 *         foo: 'bar'
 *       },
 *       success(res) {
 *         // 返回成功
 *       }
 *     })
 *     ```
 * 
 */
var chooseInvoiceTitle;
/**
 * 
 *
 * 选择用户的发票抬头。
 *
 * 需要用户授权scope.invoiceTitle
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.chooseInvoiceTitle({
 *       success(res) {
 *       }
 *     })
 *     ```
 * 
 */
var checkIsSupportSoterAuthentication;
/**
 * 
 *
 * 获取本机支持的 SOTER 生物认证方式
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.checkIsSupportSoterAuthentication({
 *         success(res) {
 *             // res.supportMode = [] 不具备任何被SOTER支持的生物识别方式
 *             // res.supportMode = ['fingerPrint'] 只支持指纹识别
 *             // res.supportMode = ['fingerPrint', 'facial'] 支持指纹识别和人脸识别
 *         }
 *     })
 *     ```
 * 
 */
var startSoterAuthentication;
/**
 * 
 *
 * 开始 SOTER 生物认证
 *
 * **生物识别方式定义：**
 *
 *   mode          |  说明         
 * ----------------|---------------
 *   fingerPrint   |  指纹识别     
 *   facial        |人脸识别（暂未支持）
 *   speech        |声纹识别（暂未支持）
 *
 * **resultJSON 说明：**
 *
 *     ```json
 *     {
 *         "raw":"msg",
 *         "fid":"2",
 *         "counter":123,
 *         "tee_n":"TEE Name",
 *         "tee_v":"TEE Version",
 *         "fp_n":"Fingerprint Sensor Name",
 *         "fp_v":"Fingerprint Sensor Version",
 *         "cpu_id":"CPU Id",
 *         "uid":"21"
 *     }
 *     ```
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.startSoterAuthentication({
 *       requestAuthModes: ['fingerPrint'],
 *       challenge: '123456',
 *       authContent: '请用指纹解锁',
 *       success(res) {
 *       }
 *     })
 *     ```
 * 
 */
var checkIsSoterEnrolledInDevice;
/**
 * 
 *
 * 获取设备内是否录入如指纹等生物信息的接口
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.checkIsSoterEnrolledInDevice({
 *         checkAuthMode: 'fingerPrint',
 *         success(res) {
 *             console.log(res.isEnrolled)
 *         }
 *     })
 *     ```
 * 
 */
/**
 * 自定义分析数据上报接口。使用前，需要在小程序管理后台自定义分析中新建事件，配置好事件名与字段。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.reportAnalytics('purchase', {
 *       price: 120,
 *       color: 'red'
 *     })
 *     ```
 * 
 */
/**
 * 
 *
 * 获取**全局唯一**的版本更新管理器，用于管理小程序更新。
 *
 *
 * **Tips：**
 *
 * 1.  开发者工具上可以通过「编译模式」下的「下次编译模拟更新」开关来调试
 * 2.  小程序开发版/体验版没有「版本」概念，所以无法在开发版/体验版上测试更版本更新情况
 *
 * **示例代码：**
 *
 *     ```javascript
 *     const updateManager = swan.getUpdateManager()
 *
 *     updateManager.onCheckForUpdate(export function (res) {
 *       // 请求完新版本信息的回调
 *       console.log(res.hasUpdate)
 *     })
 *
 *     updateManager.onUpdateReady(export function () {
 *       swan.showModal({
 *         title: '更新提示',
 *         content: '新版本已经准备好，是否重启应用？',
 *         success: export function (res) {
 *           if (res.confirm) {
 *             // 新的版本已经下载好，调用 applyUpdate 应用新版本并重启
 *             updateManager.applyUpdate()
 *           }
 *         }
 *       })
 *
 *     })
 *
 *     updateManager.onUpdateFailed(export function () {
 *       // 新的版本下载失败
 *     })
 *     ```
 * 
 */
var UpdateManager = exports.UpdateManager = /*#__PURE__*/(0, _createClass2.default)(function UpdateManager() {
  (0, _classCallCheck2.default)(this, UpdateManager);
});
/**
 * 
 *
 *
 * 创建一个 Worker 线程，并返回 Worker 实例，目前限制最多只能创建一个 Worker，创建下一个 Worker 前请调用 Worker.terminate。
 *
 * `scriptPath` 为 worker 的入口文件路径，需填写绝对路径。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     const worker = swan.createWorker('workers/request/index.js') // 文件名指定 worker 的入口文件路径，绝对路径
 *
 *     worker.onMessage(export function (res) {
 *       console.log(res)
 *     })
 *
 *     worker.postMessage({
 *       msg: 'hello worker'
 *     })
 *
 *     worker.terminate()
 *     ```
 * 
 */
var Worker = exports.Worker = /*#__PURE__*/(0, _createClass2.default)(function Worker() {
  (0, _classCallCheck2.default)(this, Worker);
});
/**
 * 
 *
 * 自定义业务数据监控上报接口。使用前，需要在小程序管理后台-运维中心-性能监控-业务数据监控中新建监控事件，配置监控描述与告警类型。每一个监控事件对应唯一的监控ID，开发者最多可以创建128个监控事件。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.reportMonitor('1', 1)
 *     ```
 * 
 */
var setEnableDebug;
/**
 * 
 *
 * 设置是否打开调试开关，此开关对正式版也能生效。
 *
 * **Tips：**
 *
 * 1.  `tip`: 在正式版打开调试还有一种方法，就是先在开发版或体验版打开调试，再切到正式版就能看到vConsole。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     // 打开调试
 *     swan.setEnableDebug({
 *         enableDebug: true
 *     })
 *
 *     // 关闭调试
 *     swan.setEnableDebug({
 *         enableDebug: false
 *     })
 *     ```
 * 
 */
/**
 * 
 *
 * 获取日志管理器 `logManager` 对象。logManager提供log、info、warn、debug四个方法写日志到文件，这四个方法接受任意个类型为Object/Array/Number/String的参数，每次调用的参数的总大小不超过100Kb。最多保存5M的日志内容，超过5M后，旧的日志内容会被删除。用户可以通过设置Button组件的`open-export type`为`feedback`来上传打印的日志。用户上传的日志可以通过登录小程序管理后台后进入左侧菜单“客服反馈”页面获取到。
 *
 * 基础库默认会把App、Page的生命周期函数和swan命名空间下的函数调用写入日志。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     const logger = swan.getLogManager()
 *     logger.log({str: 'hello world'}, 'basic log', 100, [1, 2, 3])
 *     logger.info({str: 'hello world'}, 'info log', 100, [1, 2, 3])
 *     logger.debug({str: 'hello world'}, 'debug log', 100, [1, 2, 3])
 *     logger.warn({str: 'hello world'}, 'warn log', 100, [1, 2, 3])
 *     ```
 * 
 */
// export function getLogManager(): LogManager
// export class  LogManager {
//   /**
//    * 写log日志，可以提供任意个参数，每个参数的类型为Object/Array/Number/String，参数p1到pN的内容会写入日志
//    */
//   log(p1 [: any, p2: any, ...: any, pN]: any): any
//   /**
//    * 写info日志，参数同log方法
//    */
//   info(p1 [: any, p2: any, ...: any, pN]: any): any
//   /**
//    * 写warn日志，参数同log方法
//    */
//   warn(p1 [: any, p2: any, ...: any, pN]: any): any
//   /**
//    * 写debug日志，参数同log方法
//    */
//   debug(p1 [: any, p2: any, ...: any, pN]: any): any
// }
var CanvasContext = exports.CanvasContext = /*#__PURE__*/(0, _createClass2.default)(function CanvasContext() {
  (0, _classCallCheck2.default)(this, CanvasContext);
});
var getBatteryInfo;
/**
 * 获取设备电量。
 */
var getBatteryInfoSync;
/**
 * getBatteryInfo 的同步版本。
 */